var	NUM_GROUPS = 4; // the maximum number of combat groups

var	NO_WARRIORS_AT_ALL = 1;		// the number of droids that doesn't make a cluster yet

var	MIN_VTOL_GROUPS = 1;		// the minimum number of VTOL groups
var	MAX_VTOL_GROUPS = 4;		// the maximum number of VTOL groups

var	ABS_MAX_HOVER_TRUCKS = 13;			// make sure we build at least some hover trucks

var	MAX_DISPERSE = 3; 		// the maximum dispersion of the attack group
var	RETREAT_AT = 50;		// send the unit for repair if it has this much hit point percent left
if (difficulty == EASY)
	RETREAT_AT = 0;
if (difficulty == MEDIUM)
	RETREAT_AT = 25;

var	NUM_VTOL_PADS = .25;		// this many vtols per vtol pad are allowed
var	HOTSPOT_SIZE = 6;		//Range of alertness for when enemies attack.
var	BASE_SIZE = 20;		//Range of alertness for when enemies attack the main base.
var	ARTILLERY_RANGE = 30;	//Minimum range of what the AI considers as long-range artillery (such as Howitzers and Ripple Rockets as opposed to Mortars and Mini-Rocket Arrays)

var	LOW_POWER = 1000;		//decrease ambitions when power is below this level

var	MIN_SENSOR_DISTANCE = 26;		// minimum distance between sensor towers
var	MAX_SENSOR_TANKS = 2;
var	MAX_CB_TANKS = 2;
var	MAX_DETECTOR_TANKS = 2;
var	MAX_EMP_TANKS = 8;

if (difficulty == EASY) {
	MAX_SENSOR_TANKS = 0;
	MAX_CB_TANKS = 0;
	MAX_DETECTOR_TANKS = 0;
	MAX_EMP_TANKS = 0;
}

var	EXTREME_LOW_POWER = 250;

var	buildOrder = [];

var	teamRole;	//Used for when the AI is on a team. May influence which build order the AI will use.
const	TEAM_ROLE_NORMAL=0, TEAM_ROLE_VANGUARD=1, TEAM_ROLE_SUPPORT=2;

// some definitions useful for both personality code and tail code

var	lab = "A0ResearchFacility";
var	factory = "A0LightFactory";
var	command = "A0CommandCentre";
var	generator = "A0PowerGenerator";
var	derrick = "A0ResourceExtractor";
var	borgfac = "A0CyborgFactory";
var	vtolfac = "A0VTolFactory1";
var	vtolpad = "A0VtolPad";
var	satlink = "A0Sat-linkCentre";
var	lassat = "A0LasSatCommand";
var	oilres = "OilResource";
var	oildrum = "OilDrum";
var	artifact = "Crate";
var	windfarm = "WindFarm";

var	pmod = "A0PowMod1";
var	fmod = "A0FacMod1";
var	rmod = "A0ResearchModule1";

// the following were declared as variables in order to 
// make it possible to override them in personality 
// definitions. but please don't override them unless
// the personality is to work in a modded environment.

var	sensors = [
	"Sys-SensoTowerWS", // wide spectrum sensor
	"Sys-SensoTower02", // hardened sensor
	"Sys-SensoTower01", // sensor
];

var	cbtower = [
	"Sys-CB-Tower01", // Counter-Battery Tower
];

var	detector = [
	"Sys-RadarDetector01", // Radar Detector Tower
];

var	repair = [
	"A0RepairCentre3", // repair facility
];

var sensorBodies = [
	"Body3MBT", // retaliation
	"Body2SUP", // leopard
	"Body4ABT", // bug
	"Body1REC", // viper
];

var sensorTurrets = [
	"Sensor-WideSpec", // wide spectrum sensor
	"SensorTurret1Mk1", // sensor
];

var cbTurrets = [
	"Sys-CBTurret01", // counter-battery turret
];

var detectorTurrets = [
	"RadarDetector", // radar detector
];

var	sensorPropulsions = [
	"hover01", // hover
	"wheeled01", // wheels
];

var	empBodies = sensorBodies;

var	empTurrets = [
	"EMP-Cannon", //EMP Cannon
];

var	empPropulsions = sensorPropulsions;

var	hoverPropulsions = [
	"hover01", // guess what ...
];

var	vtolPropulsions = [
	"V-Tol", // guess what ...
];

var	truckBodies = [
	"Body3MBT", // retaliation
	"Body2SUP", // leopard
	"Body4ABT", // bug
	"Body1REC", // viper
];
var	truckBodiesLight = [
];
var	truckBodiesMedium = [
];
var	truckBodiesHeavy = [
];
var	truckBodiesLightHover = [
];
var	truckBodiesMediumHover = [
];
var	truckBodiesHeavyHover = [
];

var	truckPropulsions = [
	"hover01", // hover
	"wheeled01", // wheels
];
var	truckPropulsionsLight = [
];
var	truckPropulsionsMedium = [
];
var	truckPropulsionsHeavy = [
];

var	truckTurrets = [
	"Spade1Mk1", // truck turret
];
var	truckTurretsLight = [
];
var	truckTurretsMedium = [
];
var	truckTurretsHeavy = [
];

var	engineerStats = [
	["Cyb-Bod-ComEng","CyborgSpade","CyborgLegs"], //Note: the propulsion system needs to be defined for cyborg stats in case NullBot needs to be modified to work in a mod that uses more than 1 propulsion system for cyborgs.
];

// attack this; bottom items first
var	attackTargets = [
	lab,
	borgfac,
	factory,
	vtolfac,
	satlink,
	lassat,
	derrick,
];

// attack this when going all-in
var allInAttackTargets = [
	lab,
	borgfac,
	factory,
	vtolfac,
	satlink,
	lassat,
];

// some trivial functions useful in personality definitions

// random integer between 0 and max-1 (for convenience)
function random(max) {
	if (max<=0)
		return 0;
	return Math.floor(Math.random() * max);
}

// returns true iff gameTime is less than n minutes
function earlyGame(n) {
	return (gameTime < n*60000);
}

// returns minutes of the hour; can be used as a pseudo-random number
function getTime() {
	var today = new Date();
	return today.getMinutes();
}

// returns a number that is guaranteed to be different for every team
function teamIdentifier() {
	var j=1,s=0;
	for (var i=0; i<maxPlayers; ++i) {
		if (allianceExistsBetween(me,i))
			s+=j;
		j*=2;
	}
	return s;
}

// returns the AI version, based on the file name
function nbVersionString() {
	var str=scriptName;
	switch(difficulty) {
		case EASY: str=str+" EASY"; break;
		case MEDIUM: str=str+" MEDIUM"; break;
		case HARD: str=str+" HARD"; break;
		case INSANE: str=str+" INSANE"; break;
	}
	return str;
}


// here come definitions of standard branches used by adaptive research AIs


// vocabulary to recognize common research paths from chat
// first column is the name of the path defined below, will be prefixed with "standardResearchPath" automatically
// other columns are words that name it, should be lowercase
var standardResearchPathVocabulary = [
	[ "Nothing", "0", "null", "zero", "nothing", "empty" ],
	[ "Unblock", "clear", "free", "anything", "unblock" ],
	[ "Fundamental", "fn", "fun", "fnd", "fund", "fundamental", "fundamentals" ],
	[ "Cannons", "c", "cn", "can", "cannon", "cannons" ],
	[ "Rockets", "r", "rx", "rox", "rock", "rocket", "rockets", "msl", ",missile", "missiles" ],
	[ "Flamers", "f", "fl", "flame", "flamer", "flamers", "burn" ],
	[ "Machineguns", "m", "mg", "gun", "guns", "machinegun", "machineguns"],
	[ "Lasers", "l", "ls", "las", "laser", "lasers" ],
	[ "Hurricane", "h", "hu", "hur", "hurr", "hurricane", "hurricanes" ],
	[ "Whirlwind", "w", "wh", "whirl", "whirlwind", "whirlwinds" ],
	[ "Vindicator", "v", "vi", "vin", "vind", "vindicator", "vindicators" ],
	[ "FlakCannon", "flak", "flakcannon", "flakcannons"],
	[ "Stormbringer", "s", "st", "storm", "stormie", "stormbringer", "stormbringers" ],
	[ "Ripples", "ri", "rip", "ripple", "ripples" ],
	[ "Howitzers", "ho", "how", "howy", "howies", "howiez", "howitzer", "howitzers" ],
	[ "Incendiary", "in", "inc", "plasmitebomb", "plasmitebombs", "incend", "incendiary", "incendiaries" ],
	[ "BunkerBuster", "b", "bb", "bunkerbuster", "bunkerbusters" ],
	[ "Electronic", "e", "el", "electronic", "n", "nexus", "emp" ],
	[ "Noob", "noob" ],
];

function standardSwitchResearchPath(msg) {
	if (difficulty==EASY)
		return "Dynamic research paths are not supported on Easy difficulty.";
	var path="";
	var list="";
	for (var i=0; i<standardResearchPathVocabulary.length; ++i) {
		for (j=1; j<standardResearchPathVocabulary[i].length; ++j) {
			if (msg==standardResearchPathVocabulary[i][j]) {
				path=standardResearchPathVocabulary[i][0];
			}
		}
		list=list+standardResearchPathVocabulary[i][1]+" ";
	}
	if (path!="") {
		eval("forcedResearchPath=standardResearchPath"+path+";");
		return "Switched to a new research path: "+path;
	} else {
		return "Try one of these: "+list;
	}
}

// find out whether the AI is told to stop researching
function researchBlocked() {
	if (typeof(forcedResearchPath)!="undefined")
		return forcedResearchPath[0]=="BLOCKER";
	else
		return false;
}

var standardResearchPathNothing = [
	"BLOCKER",
];

var standardResearchPathUnblock = [
];

var standardResearchPathNoob = [
	"R-Wpn-MG3Mk1",
	"R-Vehicle-Prop-Halftracks",
	"R-Wpn-Rocket02-MRL",
	"R-Wpn-Flamer-ROF01",
	"R-Wpn-Cannon-Damage02",
	"R-Wpn-Rocket-ROF03",
	"R-Wpn-MG-Damage03",
	"R-Defense-Pillbox06",
	"R-Defense-WallTower06",
	"R-Struc-RepairFacility",
	"R-Defense-AASite-QuadMg1",
	"R-Wpn-Rocket03-HvAT",
	"R-Defense-WallTower01",
	"R-Vehicle-Body08",
	"R-Defense-WallTower02",
	"R-Vehicle-Body11",
	"R-Vehicle-Prop-Hover",
	"R-Defense-WallTower03",
	"R-Wpn-Cannon-Damage05",
	"R-Cyborg-Armor-Heat01",
	"R-Wpn-AAGun-Damage01",
	"R-Struc-VTOLPad-Upgrade01",
	"R-Defense-MortarPit-Incenediary",
	"R-Defense-WallTower-HPVcannon",
	"R-Sys-CBSensor-Tower01",
	"R-Wpn-Bomb03",
	"R-Wpn-AAGun-ROF02",
	"R-Struc-Materials03",
	"R-Defense-RotMG",
	"R-Defense-Wall-RotMg",
	"R-Defense-AASite-QuadBof",
	"R-Struc-Power-Upgrade01c",
	"R-Cyborg-Hvywpn-TK",
	"R-Cyborg-Hvywpn-Mcannon",
	"R-Wpn-Bomb02",
	"R-Defense-Sunburst",
	"R-Vehicle-Body12",
	"R-Defense-HvyMor",
	"R-Vehicle-Prop-Tracks",
	"R-Struc-RprFac-Upgrade04",
	"R-Defense-Wall-VulcanCan",
	"R-Defense-Howitzer",
	"R-Defense-WallTower04",
	"R-Defense-Cannon6",
	"R-Defense-IDFRocket",
	"R-Vehicle-Body09",
	"R-Struc-Power-Upgrade03a",
	"R-Wpn-Bomb04",
	"R-Defense-Howitzer-Incenediary",
	"R-Defense-WallTower-HvyA-Trocket",
	"R-Defense-Super-Rocket",
	"R-Defense-Super-Cannon",
	"R-Defense-RotHow",
	"R-Defense-PlasmiteFlamer",
	"R-Defense-WallTower-TwinAGun",
	"R-Struc-Materials06",
	"R-Wpn-Bomb05",
	"R-Cyborg-Hvywpn-PulseLsr",
	"R-Defense-WallTower-PulseLas",
	"R-Cyborg-Hvywpn-A-T",
	"R-Cyborg-Hvywpn-RailGunner",
	"R-Defense-WallTower-Rail2",
	"R-Defense-HvyHowitzer",
	"R-Vehicle-Body10",
	"R-Struc-Research-Upgrade09",
	"R-Defense-SamSite2",
	"R-Sys-SpyTower",
	"R-Wpn-Energy-ROF03",
	"R-Wpn-Energy-Damage03",
	"R-Wpn-Missile-Damage03",
	"R-Wpn-Missile-ROF03",
	"R-Wpn-Missile-Accuracy02",
	"R-Defense-HvyArtMissile",
	"R-Defense-AA-Laser",
	"R-Defense-WallTower-A-Tmiss",
	"R-Defense-WallTower-Rail3",
	"R-Defense-Super-Missile",
	"R-Cyborg-Metals09",
	"R-Struc-VTOLPad-Upgrade06",
	"R-Cyborg-Armor-Heat09",
	"R-Vehicle-Body14",
	"R-Defense-MassDriver",
	"R-Wpn-LasSat",
	"R-Struc-Materials09",
	"R-Struc-RprFac-Upgrade06",
	"R-Defense-EMPMortar",
	"R-Defense-EMPCannon",
];
	
var standardResearchPathFundamental = [
	"R-Vehicle-Prop-Halftracks",
	"R-Struc-PowerModuleMk1",
	"R-Vehicle-Body05",
	"R-Struc-RprFac-Upgrade01",
	"R-Sys-Sensor-Tower02",
	"R-Vehicle-Body08",
	"R-Vehicle-Body11",
	"R-Cyborg-Armor-Heat03",
	"R-Struc-Power-Upgrade01c",
	"R-Sys-CBSensor-Tower01",
	"R-Vehicle-Prop-Tracks",
	"R-Struc-VTOLPad-Upgrade01",
	"R-Vehicle-Body12",
	"R-Struc-Power-Upgrade03a",
	"R-Vehicle-Body09",
	"R-Struc-VTOLPad-Upgrade03",
	"R-Sys-Autorepair-General",
	"R-Vehicle-Body10",
	"R-Wpn-LasSat",
	"R-Struc-RprFac-Upgrade04",
	"R-Cyborg-Metals09",
	"R-Cyborg-Armor-Heat09",
	"R-Vehicle-Body14",
	"R-Struc-VTOLPad-Upgrade06",
	"R-Struc-Materials09",
	"R-Struc-RprFac-Upgrade06",
];

var standardResearchPathCannons = [
	"R-Wpn-Cannon-Damage03",
	"R-Defense-WallTower02",
	"R-Defense-Pillbox04",
	"R-Defense-Emplacement-HPVcannon",
	"R-Defense-WallTower-HPVcannon",
	"R-Wpn-Cannon-Damage05",
	"R-Defense-AASite-QuadBof",
	"R-Wpn-Cannon-Damage07",
	"R-Defense-WallTower04",
	"R-Cyborg-Hvywpn-Mcannon",
	"R-Cyborg-Hvywpn-HPV",
	"R-Defense-Wall-VulcanCan",
	"R-Wpn-Cannon-ROF06",
	"R-Cyborg-Hvywpn-Acannon",
	"R-Defense-Cannon6",
	"R-Defense-Super-Cannon",
	"R-Wpn-Cannon-Damage09",
	"R-Cyborg-Hvywpn-RailGunner",
	"R-Defense-WallTower-Rail2",
	"R-Defense-WallTower-Rail3",
	"R-Defense-MassDriver",
];

var standardResearchPathRockets = [
	"R-Wpn-Rocket-Damage02",
	"R-Defense-Pillbox06",
	"R-Wpn-Rocket-ROF01",
	"R-Defense-MRL",
	"R-Defense-WallTower06",
	"R-Defense-Sunburst",
	"R-Wpn-Rocket-ROF03",
	"R-Defense-HvyA-Trocket",
	"R-Cyborg-Hvywpn-TK",
	"R-Defense-WallTower-HvyA-Trocket",
	"R-Defense-Super-Rocket",
	"R-Defense-GuardTower-ATMiss",
	"R-Cyborg-Hvywpn-A-T",
	"R-Defense-WallTower-A-Tmiss",
	"R-Defense-MdArtMissile",
	"R-Wpn-Missile-Damage03",
	"R-Wpn-Missile-ROF03",
	"R-Wpn-Missile-Accuracy02",
	"R-Defense-Super-Missile",
];

var standardResearchPathMachineguns = [
	"R-Wpn-MG-Damage02",
	"R-Defense-Tower01",
	"R-Defense-Pillbox01",
	"R-Wpn-MG3Mk1",
	"R-Wpn-MG-ROF02",
	"R-Defense-AASite-QuadMg1",
	"R-Wpn-MG-ROF03",
	"R-Wpn-AAGun-Damage01",
	"R-Defense-Wall-RotMg",
	"R-Wpn-AAGun-ROF02",
	"R-Defense-RotMG",
	"R-Wpn-MG-Damage04",
	"R-Defense-WallTower-TwinAGun",
	"R-Wpn-MG-Damage05",
];

var standardResearchPathFlamers = [
	"R-Wpn-Flamer-ROF01",
	"R-Wpn-Flamer-Damage03",
	"R-Defense-HvyFlamer",
	"R-Vehicle-Prop-Hover",
	"R-Wpn-Flamer-ROF03",
	"R-Defense-PlasmiteFlamer",
	"R-Wpn-Flamer-Damage09",
];

var standardResearchPathLasers = [
	"R-Cyborg-Hvywpn-PulseLsr",
	"R-Defense-WallTower-PulseLas",
	"R-Wpn-Energy-ROF03",
	"R-Wpn-Energy-Damage03",
];

var standardResearchPathHurricane = [
	"R-Defense-AASite-QuadMg1",
	"R-Wpn-AAGun-ROF02",
	"R-Wpn-AAGun-Damage03",
];

var standardResearchPathWhirlwind = [
	"R-Defense-AASite-QuadRotMg",
	"R-Wpn-AAGun-ROF03",
];

var standardResearchPathVindicator = [
	"R-Defense-Sunburst",
	"R-Defense-SamSite1",
	"R-Defense-SamSite2",
];

var standardResearchPathFlakCannon = [
	"R-Defense-AASite-QuadBof",
];

var standardResearchPathStormbringer = [
	"R-Defense-AA-Laser",
];

var standardResearchPathRipples = [
	"R-Defense-IDFRocket",
	"R-Defense-HvyArtMissile",
];

var standardResearchPathHowitzers = [
	"R-Defense-MortarPit",
	"R-Defense-HvyMor",
	"R-Wpn-Bomb01",
	"R-Struc-VTOLPad-Upgrade01",
	"R-Defense-Howitzer",
	"R-Wpn-Bomb02",
	"R-Defense-HvyHowitzer",
	"R-Wpn-Howitzer-Damage06",
	"R-Wpn-Howitzer-ROF04",
	"R-Wpn-Howitzer-Accuracy03",
];

var standardResearchPathIncendiary = [
	"R-Defense-MortarPit-Incenediary",
	"R-Wpn-Bomb03",
	"R-Struc-VTOLPad-Upgrade01",
	"R-Defense-Howitzer-Incenediary",
	"R-Wpn-Bomb04",
	"R-Wpn-Howitzer-Damage03",
	"R-Wpn-Howitzer-ROF04",
	"R-Wpn-Howitzer-Accuracy03",
	"R-Wpn-Bomb05",
];
	
var standardResearchPathBunkerBuster = [
	"R-Defense-MRL",
	"R-Wpn-Rocket03-HvAT",
];

var standardResearchPathElectronic = [
	"R-Sys-SpyTower",
	"R-Defense-EMPMortar",
	"R-Defense-EMPCannon",
];

var standardTankBodies = [
	[
		"Body10MBT", // vengeance
		"Body7ABT", // retribution
		"Body9REC", // tiger
		"Body12SUP", // mantis
		"Body6SUPP", // panther
		"Body8MBT", // scorpion
		"Body11ABT", // python
		"Body3MBT", // retaliation
		"Body5REC", // cobra
		"Body2SUP", // leopard
		"Body4ABT", // bug
		"Body1REC", // viper
	],
	[
		"Body14SUP", // dragon
		"Body13SUP", // wyvern
		"Body10MBT", // vengeance
		"Body9REC", // tiger
		"Body7ABT", // retribution
		"Body6SUPP", // panther
		"Body12SUP", // mantis
		"Body11ABT", // python
		"Body8MBT", // scorpion
		"Body3MBT", // retaliation
		"Body5REC", // cobra
		"Body2SUP", // leopard
		"Body4ABT", // bug
		"Body1REC", // viper
	],
];

var standardTankBodiesLight = [
	"Body10MBT", // vengeance
	"Body7ABT", // retribution
	"Body12SUP", // mantis
	"Body8MBT", // scorpion
	"Body11ABT", // python
	"Body9REC", // tiger
	"Body3MBT", // retaliation
	"Body5REC", // cobra
	"Body6SUPP", // panther
	"Body4ABT", // bug
	"Body1REC", // viper
	"Body2SUP", // leopard
];

var standardTankBodiesHeavy = [
	"Body14SUP", // dragon
	"Body13SUP", // wyvern
	"Body10MBT", // vengeance
	"Body7ABT", // retribution
	"Body9REC", // tiger
	"Body11ABT", // python
	"Body12SUP", // mantis
	"Body3MBT", // retaliation
	"Body6SUPP", // panther
	"Body5REC", // cobra
	"Body8MBT", // scorpion
	"Body2SUP", // leopard
	"Body1REC", // viper
	"Body4ABT", // bug
];

var standardTankPropulsions = [
	[
		"tracked01", // tracks
		"HalfTrack", // half-track
		"wheeled01", // wheels
	],
	[
		"hover01", // hover
		"HalfTrack", // half-track
		"wheeled01", // wheels
	],
];

var standardTankPropulsionsNoob = [
	[
		"tracked01", // tracks
		"HalfTrack", // half-track
		"wheeled01", // wheels
	],
	[
		"HalfTrack", // half-track
		"wheeled01", // wheels
	],
	[
		"hover01", // hover
		"wheeled01", // wheels
	],
];

var standardTankPropulsionsHover = [
	[
		"hover01", // hover
	],
];

var standardTankATNoobOne = [
	"RailGun3Mk1", // gauss cannon
	"RailGun2Mk1", // rail gun
	"Missile-A-T", // scourge
	"Cannon6TwinAslt", // twin assault cannon
	"Cannon375mmMk1", // heavy cannon
	"Rocket-HvyA-T", // tk
	"Cannon4AUTOMk1", // hpv
	"Cannon2A-TMk1", // medium cannon
	"Rocket-LtA-T", // lancer
	"Cannon1Mk1", // light cannon
	"Rocket-Pod", // minipod
];

var standardTankATNoobTwo = [
	"Missile-A-T", // scourge
	"RailGun3Mk1", // gauss cannon
	"RailGun2Mk1", // rail gun
	"Rocket-HvyA-T", // tk
	"Cannon375mmMk1", // heavy cannon
	"Cannon6TwinAslt", // twin assault cannon
	"Rocket-LtA-T", // lancer
	"Cannon2A-TMk1", // medium cannon
	"Cannon4AUTOMk1", // hpv
	"Rocket-Pod", // minipod
	"Cannon1Mk1", // light cannon
];

var standardTankAPNoobOne = [
	"Laser2PULSEMk1", // pulse laser
	"Laser3BEAMMk1", // flashlight
	"MG5TWINROTARY", // tag
	"MG4ROTARYMk1", // ag
	"MG3Mk1", // hmg
	"MG2Mk1", // tmg
	"MG1Mk1", // mg
];

var standardTankAPNoobTwo = [
	"Missile-MdArt", // seraph
	"Laser2PULSEMk1", // pulse laser
	"Laser3BEAMMk1", // flashlight
	"PlasmiteFlamer", // plasmite
	"Flame2", // inferno
	"MG5TWINROTARY", // tag
	"MG4ROTARYMk1", // ag
	"Rocket-MRL", // mini-rocket arty
	"Flame1Mk1", // flamer
	"MG3Mk1", // hmg
	"MG2Mk1", // tmg
	"MG1Mk1", // mg
];

var standardTankCannonOne = [
	"RailGun3Mk1", // gauss cannon
	"RailGun2Mk1", // rail gun
	"Cannon6TwinAslt", // twin assault cannon
	"Cannon375mmMk1", // heavy cannon
	"Cannon4AUTOMk1", // hpv
	"Cannon2A-TMk1", // medium cannon
	"Cannon1Mk1", // light cannon
];

var standardTankCannonTwo = [
	"RailGun3Mk1", // gauss cannon
	"RailGun2Mk1", // rail gun
	"Cannon375mmMk1", // heavy cannon
	"Cannon6TwinAslt", // twin assault cannon
	"Cannon2A-TMk1", // medium cannon
	"Cannon4AUTOMk1", // hpv
	"Cannon1Mk1", // light cannon
];

var standardTankRocket = [
	"Missile-A-T", // scourge
	"Rocket-HvyA-T", // tk
	"Rocket-LtA-T", // lancer
	"Rocket-MRL", // mini-rocket arty, not really AT but still better than minipod in most cases
	"Rocket-Pod", // minipod
];

var standardTankMachinegun = [
	"MG5TWINROTARY", // tag
	"MG4ROTARYMk1", // ag
	"MG3Mk1", // hmg
	"MG2Mk1", // tmg
	"MG1Mk1", // mg
];

var standardTankFlamer = [
	"PlasmiteFlamer", // plasmite
	"Flame2", // inferno
	"Flame1Mk1", // flamer
	"MG2Mk1", // tmg
	"MG1Mk1", // mg
];

var standardTankLaser = [
	"Laser2PULSEMk1", // pulse laser
];

var standardTankAPRocket = [
	"Missile-MdArt", // seraph
	"Rocket-MRL", // mini-rocket arty
];

var standardTankAPMachinegunRocket = [
	"Missile-MdArt", // seraph
	"MG5TWINROTARY", // tag
	"MG4ROTARYMk1", // ag
	"Rocket-MRL", // mini-rocket arty
	"MG3Mk1", // hmg
	"MG2Mk1", // tmg
	"MG1Mk1", // mg
];

var standardTankAB = [
	[
		"Missile-MdArt", // seraph
		"Howitzer-Incenediary", // incendiary howitzer
		"Howitzer03-Rot", // hellstorm
		"Howitzer105Mk1", // howitzer
		"Mortar-Incenediary", // incendiary mortar
		"Mortar2Mk1", // bombard
		"Mortar3ROTARYMk1", // pepperpot
		"Rocket-BB", // bunker buster
		"Rocket-MRL", // mra
		"Mortar1Mk1", // mortar
	],
	[
		"Missile-MdArt", // seraph
		"Howitzer03-Rot", // hellstorm
		"Howitzer-Incenediary", // incendiary howitzer
		"Howitzer105Mk1", // howitzer
		"Mortar2Mk1", // bombard
		"Mortar3ROTARYMk1", // pepperpot
		"Mortar-Incenediary", // incendiary mortar
		"Rocket-BB", // bunker buster
		"Rocket-MRL", // mra
		"Mortar1Mk1", // mortar
	],
	[
		"Howitzer03-Rot", // hellstorm
		"Howitzer-Incenediary", // incendiary howitzer
		"Missile-MdArt", // seraph
		"Mortar3ROTARYMk1", // pepperpot
		"Mortar-Incenediary", // incendiary mortar
		"Mortar2Mk1", // bombard
		"Rocket-BB", // bunker buster
		"Rocket-MRL", // mra
		"Mortar1Mk1", // mortar
	],
	[
		"Missile-MdArt", // seraph
		"Rocket-BB", // bunker buster
		"Rocket-MRL", // mra
	],
];

var standardTankAA = [
	[
		"AAGunLaser", // stormbringer
		"Missile-HvySAM", // vindicator
		"Missile-LtSAM", // avenger
		"QuadRotAAGun", // whirlwind
		"AAGun2Mk1", // flak cannon
		"Rocket-Sunburst", // sunburst
		"QuadMg1AAGun", // hurricane
	],
];


var standardCyborgAPNoobOne = [
	["Cyb-Hvybod-PulseLsr","Cyb-Hvywpn-PulseLsr","CyborgLegs"], // super pulse
	["Cyb-Bod-Las1","Cyb-Wpn-Laser","CyborgLegs"], // flashlight
	["CybRotMgGrd","CyborgRotMG","CyborgLegs"], // assault gun
	["Cyb-Bod-Grenade", "Cyb-Wpn-Grenade","CyborgLegs"], // mortar
	["CyborgChain1Ground", "CyborgChaingun","CyborgLegs"], // machinegun
];

var standardCyborgAPNoobTwo = [
	["Cyb-Hvybod-PulseLsr","Cyb-Hvywpn-PulseLsr","CyborgLegs"], // super pulse
	["Cyb-Bod-Las1","Cyb-Wpn-Laser","CyborgLegs"], // flashlight
	["CybRotMgGrd","CyborgRotMG","CyborgLegs"], // assault gun
	["Cyb-Bod-Thermite", "Cyb-Wpn-Thermite","CyborgLegs"], // thermite
	["CyborgFlamerGrd", "CyborgFlamer01","CyborgLegs"], // flamer
	["CyborgChain1Ground", "CyborgChaingun","CyborgLegs"], // machinegun
];

var standardCyborgATNoobOne = [
	["Cyb-Hvybod-A-T","Cyb-Hvywpn-A-T","CyborgLegs"], // super scourge
	["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","CyborgLegs"], // super rail
	["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"], // needle
	["Cyb-Bod-Atmiss","Cyb-Wpn-Atmiss","CyborgLegs"], // scourge
	["Cyb-Hvybod-Acannon","Cyb-Hvywpn-Acannon","CyborgLegs"], // super auto cannon
	["CyborgRkt1Ground", "CyborgRocket","CyborgLegs"], // lancer
	["CyborgCannonGrd", "CyborgCannon","CyborgLegs"], // cannon
];

var standardCyborgATNoobTwo = [
	["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","CyborgLegs"], // super rail
	["Cyb-Hvybod-A-T","Cyb-Hvywpn-A-T","CyborgLegs"], // super scourge
	["Cyb-Bod-Atmiss","Cyb-Wpn-Atmiss","CyborgLegs"], // scourge
	["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"], // needle
	["Cyb-Hvybod-HPV","Cyb-Hvywpn-HPV","CyborgLegs"], // super hpv cannon
	["CyborgRkt1Ground", "CyborgRocket","CyborgLegs"], // lancer
	["CyborgCannonGrd", "CyborgCannon","CyborgLegs"], // cannon
];

var standardCyborgATNoobThree = [
	["Cyb-Hvybod-A-T","Cyb-Hvywpn-A-T","CyborgLegs"], // super scourge
	["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","CyborgLegs"], // super rail
	["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"], // needle
	["Cyb-Bod-Atmiss","Cyb-Wpn-Atmiss","CyborgLegs"], // scourge
	["Cyb-Hvybod-TK","Cyb-Hvywpn-TK","CyborgLegs"], // super tk
	["Cyb-Hvybod-Mcannon","Cyb-Hvywpn-Mcannon","CyborgLegs"], // super cannon
	["CyborgRkt1Ground", "CyborgRocket","CyborgLegs"], // lancer
	["CyborgCannonGrd", "CyborgCannon","CyborgLegs"], // cannon
];


var standardCyborgCannonOne = [
	["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","CyborgLegs"], // super rail
	["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"], // needle
	["Cyb-Hvybod-Acannon","Cyb-Hvywpn-Acannon","CyborgLegs"], // super auto cannon
	["CyborgCannonGrd", "CyborgCannon","CyborgLegs"], // cannon
];

var standardCyborgCannonTwo = [
	["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","CyborgLegs"], // super rail
	["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"], // needle
	["Cyb-Hvybod-HPV","Cyb-Hvywpn-HPV","CyborgLegs"], // super hpv cannon
	["CyborgCannonGrd", "CyborgCannon","CyborgLegs"], // cannon
];
var standardCyborgCannonThree = [
	["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","CyborgLegs"], // super rail
	["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"], // needle
	["Cyb-Hvybod-Mcannon","Cyb-Hvywpn-Mcannon","CyborgLegs"], // super cannon
	["CyborgCannonGrd", "CyborgCannon","CyborgLegs"], // cannon
];

var standardCyborgRocket = [
	["Cyb-Hvybod-A-T","Cyb-Hvywpn-A-T","CyborgLegs"], // super scourge
	["Cyb-Bod-Atmiss","Cyb-Wpn-Atmiss","CyborgLegs"], // scourge
	["Cyb-Hvybod-TK","Cyb-Hvywpn-TK","CyborgLegs"], // super tk
	["CyborgRkt1Ground", "CyborgRocket","CyborgLegs"], // lancer
];

var standardCyborgMachinegun = [
	["CybRotMgGrd","CyborgRotMG","CyborgLegs"], // assault gun
	["CyborgChain1Ground", "CyborgChaingun","CyborgLegs"], // machinegun
];

var standardCyborgFlamer = [
	["Cyb-Bod-Thermite", "Cyb-Wpn-Thermite","CyborgLegs"], // thermite
	["CyborgFlamerGrd", "CyborgFlamer01","CyborgLegs"], // flamer
];

var standardCyborgLaser = [
	["Cyb-Hvybod-PulseLsr","Cyb-Hvywpn-PulseLsr","CyborgLegs"], // super pulse
	["Cyb-Bod-Las1","Cyb-Wpn-Laser","CyborgLegs"], // flashlight
];

var standardCyborgMachinegunMortar = [
	["CybRotMgGrd","CyborgRotMG","CyborgLegs"], // assault gun
	["Cyb-Bod-Grenade", "Cyb-Wpn-Grenade","CyborgLegs"], // mortar
	["CyborgChain1Ground", "CyborgChaingun","CyborgLegs"], // machinegun
];

// standard build order definitions

function standardBuildOrderNoob() {
	// a noob doesn't know what a build order is, so it relies
	// on keepBuildingThings() from the start
	return false;
}

function standardBuildOrderFRCFR() {
	// Builds initial structures in the following order:
	//     factory, lab, cc, factory, generator, lab, factory, generator, lab.
	//     * Doesn't build 3rd lab until 10th minute of the game.
	// Also make sure we have at least one generator before our initial money runs out
	var labCount = enumStruct(me, lab).length;
	var factoryCount = enumStruct(me, factory).length;
	var commandCount = enumStruct(me, command).length;
	var genCount = enumStruct(me, generator).length;
	var derrickCount = enumStruct(me, derrick).length;
	var borgCount = enumStruct(me, borgfac).length;
	var vtolCount = enumStruct(me, vtolfac).length;
	if (genCount < 2 && playerPower(me) < EXTREME_LOW_POWER && isStructureAvailable(generator,me))
		return buildBasicStructure(generator); 
	if (factoryCount < 1 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory); 
	if (labCount < 1 && isStructureAvailable(lab,me) && !researchBlocked())
		return buildBasicStructure(lab); 
	if (commandCount < 1 && isStructureAvailable(command,me))
		return buildBasicStructure(command); 
	if (factoryCount < 2 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory,0); 
	if ((genCount < 1) && isStructureAvailable(generator,me))
		return buildBasicStructure(generator); 
	if (labCount < 2 && isStructureAvailable(lab,me) && !researchBlocked())
		return buildBasicStructure(lab,0); 
	if (factoryCount < 3 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory,0); 
	if ((genCount < 2) && isStructureAvailable(generator,me))
		return buildBasicStructure(generator,0); 
	if (labCount < 3 && isStructureAvailable(lab,me) && !researchBlocked() && (!earlyGame(10)&&!UNUSUAL_SITUATION))
		return buildBasicStructure(lab,0); 
	if (borgCount < 2 && isStructureAvailable(borgfac,me) && RATE_TANK>0)
		return buildBasicStructure(borgfac,0); 
	if (vtolCount < 1 && isStructureAvailable(vtolfac,me))
		return buildBasicStructure(vtolfac,0); 
	return false;
}

function standardBuildOrderRFFRC() {
	// Builds initial structures in the following order:
	//     lab, factory, factory, lab, command center, generator, generator, factory, lab.
	//     * Doesn't build 3rd factory until 8th minute of the game.
	//     * Doesn't build 3rd lab until 10th minute of the game.
	// Also make sure we have at least one generator before our initial money runs out
	var labCount = enumStruct(me, lab).length;
	var factoryCount = enumStruct(me, factory).length;
	var commandCount = enumStruct(me, command).length;
	var genCount = enumStruct(me, generator).length;
	var derrickCount = enumStruct(me, derrick).length;
	var borgCount = enumStruct(me, borgfac).length;
	var vtolCount = enumStruct(me, vtolfac).length;
	if (genCount < 2 && playerPower(me) < EXTREME_LOW_POWER && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (labCount < 1 && isStructureAvailable(lab,me) && !researchBlocked())
		return buildBasicStructure(lab);
	if (factoryCount < 1 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory);
	if (factoryCount < 2 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory,0);
	if (labCount < 2 && isStructureAvailable(lab,me) && !researchBlocked())
		return buildBasicStructure(lab,0);
	if (commandCount < 1 && isStructureAvailable(command,me))
		return buildBasicStructure(command,0);
	if ((genCount < 2) && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (factoryCount < 3 && isStructureAvailable(factory,me) && (!earlyGame(8)&&!UNUSUAL_SITUATION))
		return buildBasicStructure(factory,0);
	if (labCount < 3 && isStructureAvailable(lab,me) && !researchBlocked() && (!earlyGame(10)&&!UNUSUAL_SITUATION))
		return buildBasicStructure(lab,0);
	if (borgCount < 2 && isStructureAvailable(borgfac,me) && RATE_TANK>0)
		return buildBasicStructure(borgfac,0);
	if (vtolCount < 1 && isStructureAvailable(vtolfac,me)) 
		return buildBasicStructure(vtolfac,0);
	return false;
}

function standardBuildOrderRFFCR() {
	// Builds initial structures in the following order:
	//     lab, factory, factory, command center, lab, generator, generator, factory, factory, lab
	//     * Doesn't build 3rd lab until 15th minute of the game.
	// Also make sure we have at least one generator before our initial money runs out
	var labCount = enumStruct(me, lab).length;
	var factoryCount = enumStruct(me, factory).length;
	var commandCount = enumStruct(me, command).length;
	var genCount = enumStruct(me, generator).length;
	var derrickCount = enumStruct(me, derrick).length;
	var borgCount = enumStruct(me, borgfac).length;
	var vtolCount = enumStruct(me, vtolfac).length;
	if (genCount < 2 && playerPower(me) < EXTREME_LOW_POWER && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (labCount < 1 && isStructureAvailable(lab,me) && !researchBlocked())
		return buildBasicStructure(lab);
	if (factoryCount < 1 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory);
	if (factoryCount < 2 && isStructureAvailable(factory,me))
		return buildBasicStructure(factory,0);
	if (commandCount < 1 && isStructureAvailable(command,me))
		return buildBasicStructure(command,0);
	if (labCount < 2 && isStructureAvailable(lab,me) && !researchBlocked())
		return buildBasicStructure(lab,0);
	if ((genCount < 2) && isStructureAvailable(generator,me))
		return buildBasicStructure(generator);
	if (factoryCount < 4 && isStructureAvailable(factory,me) && (!UNUSUAL_SITUATION))
		return buildBasicStructure(factory,0);
	if (labCount < 3 && isStructureAvailable(lab,me) && !researchBlocked() && (!earlyGame(15)&&!UNUSUAL_SITUATION))
		return buildBasicStructure(lab,0);
	if (borgCount < 3 && isStructureAvailable(borgfac,me) && RATE_TANK>0)
		return buildBasicStructure(borgfac,0);
	if (vtolCount < 1 && isStructureAvailable(vtolfac,me)) 
		return buildBasicStructure(vtolfac,0);
	return false;
}