
var	UNUSUAL_SITUATION = 0;
// UNUSUAL_SITUATION is true if we are participating in challenge of some sort;
// this is detected at eventStartLevel and does some tweaks to the AI to make it
// behave more campaign-like during challenges

var	HIGH_TECH_START = 0;
// Defined at start of the game, this value remembers if we have started at T2
// or at least at T1/advbases

var	MAX_WARRIORS = 150;		// the maximum number of droids in a group
var	NUM_WARRIORS;			// the number of battle droids to maintain in a single group
var	MIN_WARRIORS;			// the number of battle droids necessary to engage in combat
var	MIN_VTOLS;				// the minimum number of vtols to have in attack group before attack
var	NUM_VTOLS;				// thenumber of vtols to maintain in an attack group
var	MAX_VTOLS = 32;			// the maximum size of a vtol attack group
var	NUM_HARASS;				// the number of units to maintain in the harass group

var	MIN_DEFENDERS_AA;			//The minimum number of anti-air units to maintain within the base.
var	MIN_ARTILLERY;			//The minimum number of long-range artillery structures to maintain throughout the entire map.

var	NUM_VTOL_GROUPS = MIN_VTOL_GROUPS;
var	ABS_MAX_TRUCKS = 10;			// try not to make too many trucks

var	RATE_AP = 4;		// these values affect the amount of a certain weapon class in the mix
var	RATE_AT = 4;		// this is for anti-tank
var	RATE_AA = 1;		// how much more AA do we need
var	RATE_AB = 1;		// this is for anti-building

var	RATE_AP_LIGHT = 8;	//These values affect the odds that the AI would build a certain size class of tank with the specified role.
var	RATE_AP_MEDIUM = 4;
var	RATE_AP_HEAVY = 2;
var	RATE_AP_SUPER = 1;
var	RATE_AP_SUPER_A = 1;	//Affects chances that, if a multi-turret tank is chosen, that it would mount an ultra-heavy turret and a light turret.
var	RATE_AP_SUPER_B = 1;	//Affects chances that, if a multi-turret tank is chosen, that it would mount two heavy turrets.

var	RATE_AT_LIGHT = 8;	//This is for anti-tank vehicles.
var	RATE_AT_MEDIUM = 4;
var	RATE_AT_HEAVY = 2;
var	RATE_AT_SUPER = 1;
var	RATE_AT_SUPER_A = 1;
var	RATE_AT_SUPER_B = 1;

var	RATE_AA_LIGHT = 8;	//This is for anti-air vehicles.
var	RATE_AA_MEDIUM = 4;
var	RATE_AA_HEAVY = 2;
var	RATE_AA_SUPER = 1;
var	RATE_AA_SUPER_A = 1;
var	RATE_AA_SUPER_B = 1;

var	RATE_AB_LIGHT = 8;	//This is for anti-structure vehicles.
var	RATE_AB_MEDIUM = 4;
var	RATE_AB_HEAVY = 2;
var	RATE_AB_SUPER = 1;
var	RATE_AB_SUPER_A = 1;
var	RATE_AB_SUPER_B = 1;

var	RATE_VTOL_AP_LIGHT = 8;		//This is for anti-personnel vtols.
var	RATE_VTOL_AP_MEDIUM = 4;
var	RATE_VTOL_AP_HEAVY = 2;
var	RATE_VTOL_AP_SUPER = 1;
var	RATE_VTOL_AP_SUPER_A = 1;
var	RATE_VTOL_AP_SUPER_B = 1;

var	RATE_VTOL_AT_LIGHT = 8;		//This is for anti-tank vtols.
var	RATE_VTOL_AT_MEDIUM = 4;
var	RATE_VTOL_AT_HEAVY = 2;
var	RATE_VTOL_AT_SUPER = 1;
var	RATE_VTOL_AT_SUPER_A = 1;
var	RATE_VTOL_AT_SUPER_B = 1;

var	RATE_VTOL_AB_LIGHT = 8;		//This is for anti-structure vtols.
var	RATE_VTOL_AB_MEDIUM = 4;
var	RATE_VTOL_AB_HEAVY = 2;
var	RATE_VTOL_AB_SUPER = 1;
var	RATE_VTOL_AB_SUPER_A = 1;
var	RATE_VTOL_AB_SUPER_B = 1;

var	RATE_VTOL_AA_LIGHT = 8;		//This is for anti-air vtols.
var	RATE_VTOL_AA_MEDIUM = 4;
var	RATE_VTOL_AA_HEAVY = 2;
var	RATE_VTOL_AA_SUPER = 1;
var	RATE_VTOL_AA_SUPER_A = 1;
var	RATE_VTOL_AA_SUPER_B = 1;

var	BUILD_TANKS = 1;		//Useful for controlling whether or not to produce tanks, borgs, or vtols at certain points.
var	BUILD_BORGS = 1;		//Only used by HARD and INSANE AIs.
var	BUILD_VTOLS = 1;

var	RATE_TANK = 1;		// these values affect the amount of hover tanks in the mix
var	RATE_HOVER = 0;

var	PEACEFULNESS;			//This influences the AI's likelihood of launching "All-In" assaults on enemy bases. A smaller value indicates a more aggressive (reckless?) AI.
var	ALL_IN_THRESHOLD = 120;		//This determines the minimum number of units the AI will need to possess in total to launch "All-In" assaults against enemies in an effort to free up unit space.
var	BECOMES_HARDER = 0;		//Controls whether or not to change group sizes during the match.
var	REGROUP_FREQUENCY;		//Controls how often the AI regroups its attack forces.

if (difficulty == EASY) {
	PEACEFULNESS = 1.5;		//For an EASY AI, we'll want it to be a pushover that focuses on turtling,
	REGROUP_FREQUENCY = 0;		//doesn't regroup at all,
	MIN_WARRIORS = 5;
	NUM_WARRIORS = 8;
	MIN_VTOLS = 5;
	NUM_VTOLS = 8;
	NUM_HARASS = 0;			//doesn't harass at all,
	MIN_ARTILLERY = 0;		//and doesn't build any artillery.
}
else if (difficulty == MEDIUM) {
	PEACEFULNESS = .75;		//For a MEDIUM AI, we'll want it to be fairly competent, if somewhat reckless,
	REGROUP_FREQUENCY = 15000;	//regroup less frequently,
	MIN_WARRIORS = 10;
	NUM_WARRIORS = 20;
	MIN_VTOLS = 10;
	NUM_VTOLS = 20;
	NUM_HARASS = 8;			//do a little harassing,
	MIN_ARTILLERY = 8;		//and build some artillery early on.
}
else {
	PEACEFULNESS = .9;		//For a HARD or INSANE AI, we'll want it to be merciless, but not too aggressive...
	REGROUP_FREQUENCY = 5000;	//regroup often,
	MIN_WARRIORS = 16;
	NUM_WARRIORS = 24;
	MIN_VTOLS = 16;
	NUM_VTOLS = 24;
	NUM_HARASS = 32;			//build many harassers,
	MIN_ARTILLERY = 32;		//and build alot of artillery early on.
}

	/********************************/
	/* Generic branch specific code */
	/********************************/

function constructPersonality() {

	this.MIN_BUILDERS = 2;		// the usual number of trucks that construct base structures
	this.MAX_BUILDERS = 4;		// the maximum number of trucks that construct base structures
	this.MIN_OILERS = 4;		// the usual number of trucks used for oil hunting
	this.MAX_OILERS = 10;		// the maximum number of trucks used for oil hunting
	this.MIN_DEFENDERS = 4;		// the minimum number of tanks before producing more trucks than necessary
	this.DEFENSIVENESS;		// regulates chance of spending money on defensive structures.
	this.PEACE_TIME;			// the amount of minutes for free scouting (regrouping disabled, no defenses built)

	this.THIS_AI_MAKES_TANKS = true;
	this.THIS_AI_MAKES_CYBORGS = true;
	this.THIS_AI_MAKES_VTOLS = true;
	this.THIS_AI_BUILDS_ARTILLERY = true;

	if (difficulty == EASY) {
		this.DEFENSIVENESS = 4;				//For an EASY AI, we'll want it to turtle some,
		this.PEACE_TIME = 0;				//to not bother with scouting or early-game rushing or harassing,
		this.THIS_AI_MAKES_CYBORGS = false;		//to prefer more expensive tanks over cheaper cyborgs,
		this.THIS_AI_BUILDS_ARTILLERY = false;	//and to not bother with building any artillery.
	}
	else if (difficulty == MEDIUM) {
		this.DEFENSIVENESS = 1;				//For a MEDIUM AI, we'll want it to be slightly defensive,
		this.PEACE_TIME = 3.5;				//and attempt to rush and overwhelm the opponent early.
	}
	else {
		this.DEFENSIVENESS = .25;			//For a HARD or INSANE AI, we'll want it to not rely on defenses,
		this.PEACE_TIME = 3.5;				//and attempt to control the majority of the map's oil early.
	}

	if (typeof(forcePersonality)=="undefined") {
		this.subpersonality = random(3);
		if (this.subpersonality>=1)
			this.subpersonality+=1; //To be changed later on...
	}
	else
		this.subpersonality = forcePersonality;

	this.harassBodies = [contingencyBodiesSuperArmored,];
	this.harassBodies[0] = this.harassBodies[0].concat(contingencyBodiesHeavyArmored,contingencyBodiesMediumArmored,contingencyBodiesLightArmored);
	this.harassPropulsions = [
	[
		"hover01",
		"wheeled01",
	],
	];
	this.harassWeapons = [
	[
		"SpyTurretNEXUS",
		"SpyTurret03",
		"SpyTurret02",
		"SpyTurret01",
	],
	];

	this.researchPathEconomy = [
		"R-Struc-PowerModuleMk1",
		"R-Struc-WindFarm",
		"R-Struc-Power-Upgrade03",
		"R-Struc-Power-Upgrade06",
		"R-Struc-Power-Upgrade09",
	];
	
	this.researchPathFundamentalAA = [
		"R-Wpn-Rocket05-MiniPod",
	];
	
	this.researchPathHover = [
		"R-Struc-Research-Module", //We should prioritize research upgrades over power upgrades,
		"R-Struc-Research-Upgrade01", //and power upgrades over everything else.
		"R-Struc-PowerModuleMk1",
		"R-Vehicle-Prop-Hover",
		"R-Struc-Research-Upgrade04", //Although not necessary, researching research upgrades should allow us to research hovers quicker.
		"R-Struc-WindFarm", //Wind Farms should provide us a nice way of investing our power into something useful until we can get hovers.
	];

	//The following arrays are blacklists that provide a quick means of preventing AIs from researching those technologies
	//(unless they're required for some other technology) without having to create and use duplicate research paths.
	
	this.hoverBlacklist = [ //Prevents research into any propulsion systems that aren't capable of crossing bodies of water.
		"R-Vehicle-Prop-Halftracks",
		"R-Vehicle-Prop-Tracks",
		"R-Struc-Factory-Cyborg",
		"R-Wpn-Cannon-Sniper",
		"R-Wpn-Railgun-Sniper",
	];
	
	switch (this.subpersonality) {
	case 0: //Machinegun Personality

		this.tankBodies = [contingencyBodiesSuperArmored,];
		this.tankBodies[0] = this.tankBodies[0].concat(contingencyBodiesHeavyArmored,contingencyBodiesMediumArmored,contingencyBodiesLightArmored);
	
		this.tankBodiesLight = [contingencyBodiesLightArmored,];
		this.tankBodiesMedium = [contingencyBodiesMediumArmored,];
		this.tankBodiesHeavy = [contingencyBodiesHeavyArmored,];
		this.tankBodiesSuper = [contingencyBodiesSuperArmored,];
		
		sensorBodies = contingencyBodiesHeavyArmored;
		empBodies = contingencyBodiesMediumArmored;

		this.tankPropulsions = [
		[
			"tracked01", // tracks
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		sensorPropulsions = this.tankPropulsions[0];
		empPropulsions = this.tankPropulsions[0];

		RATE_AT_LIGHT = 1;	//Due to a huge surplus of high rate-of-fire, low damage-per-shot weapons,
		RATE_AT_MEDIUM = 10;	//we'll need to build heavier tanks more often so that they could survive long enough
		RATE_AT_HEAVY = 20;	//to take full advantage of the machineguns' high rates-of-fire.
		RATE_AT_SUPER = 40;
		RATE_AT_SUPER_A = 1;	//Not many good choices for ultra-heavy turrets,
		RATE_AT_SUPER_B = 4;	//so we'll just build more ultra-heavy tanks with 2 heavy turrets.
		
		this.atWeapons = [
		[
			"MG-AntiTankGss",
			"MG-AntiTank2",
			"MG-AntiTank",
			"Cannon1Mk1",
		],
		];

		this.atWeaponsLight = [
		[
			"Railgun-GattlingInc",
			"Railgun-Gattling",
			"MG4Inc",
			"MG4ROTARYMk1",
			"Rocket-Pod",
			"Cannon1Mk1",
		],
		[
			"Railgun-Gattling",
			"MG4ROTARYMk1",
		],
		];
		
		this.atWeaponsMedium = [
		[
			"MG-AntiTankGss",
			"MG-AntiTank2",
			"MG-AntiTank",
		],
		[
			"MG-AntiTankGss",
			"MG-AntiTank2",
			"MG-AntiTank",
		],
		[
			"MG-AntiTankGss",
			"MG-AntiTank2",
			"MG-AntiTank",
		],
		[
			"Mortar-GaussRamjet",
			"Mortar-Ramjet",
		],
		[
			"Mortar-GaussRamjet",
			"Mortar-Ramjet",
		],
		[
			"Mortar-GaussInc",
			"Mortar-Incenediary",
		],
		];
		
		this.atWeaponsHeavy = [
		[
			"MG-AntiTankGssTwin",
			"MG-AntiTank2Twin",
			"MG-AntiTankTwin",
			"MG-AntiTank",
		],
		[
			"MG-AntiTankGssTwin",
			"MG-AntiTank2Twin",
			"MG-AntiTankTwin",
			"MG-AntiTank",
		],
		[
			"MG-AntiTankGssTwin",
			"MG-AntiTank2Twin",
			"MG-AntiTankTwin",
			"MG-AntiTank",
		],
		[
			"MG-AntiTankGssTwin",
			"MG-AntiTank2Twin",
			"MG-AntiTankTwin",
			"MG-AntiTank",
		],
		[
			"Mortar-GaussHvyPlas",
			"MortarHvyPlas",
		],
		[
			"Mortar-GaussHvy",
			"Mortar2Mk1",
		],
		[
			"Mortar-GaussRamjetRot",
			"Mortar-RamjetRot",
		],
		[
			"Mortar-GaussRamjetHvy",
			"Mortar-RamjetHvy",
		],
		];
		
		this.atWeaponsSuper = [
		[
			"Railgun-GattlingAT",
			"Cannon-HPVGattling",
			"Cannon-Gattling",
		],
		];
		
		RATE_AP_LIGHT = 1;	//Although there's no shortage of anti-personnel weapons for light tanks,
		RATE_AP_MEDIUM = 8;	//we'll need to rely more on survivability, so we'll be building more medium tanks.
		RATE_AP_HEAVY = 4;	//There aren't any viable anti-personnel machineguns for heavy tanks,
		RATE_AP_SUPER = 2;	//and it'll be a while until we have Pepperpots.
		RATE_AP_SUPER_A = 1;	//Incendiary Pepperpots and Gattling Mortars are both equally viable choices.
		RATE_AP_SUPER_B = 1;
		
		this.apWeapons = [
		[
			"Railgun-GattlingTwin",
			"Railgun-Gattling",
			"MG4IncTwin",
			"MG4Inc",
			"MG3IncTwin",
			"MG3Inc",
			"MG5TWINROTARY",
			"MG4ROTARYMk1",
			"MG3Twin",
			"MG3Mk1",
			"MG2Mk1",
			"MG1Mk1",
		],
		];

		this.apWeaponsLight = [
		[
			"Railgun-GattlingInc",
			"Railgun-Gattling",
			"MG4Inc",
			"MG4ROTARYMk1",
			"MG3Inc",
			"MG3Mk1",
			"Rocket-Pod",
			"MG2Mk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Railgun-Gattling",
			"MG4ROTARYMk1",
			"MG3Mk1",
		],
		];
		
		this.apWeaponsMedium = [
		[
			"Railgun-GattlingIncTwin",
			"Railgun-GattlingTwin",
			"MG4IncTwin",
			"MG5TWINROTARY",
			"MG3IncTwin",
			"MG3Twin",
			"MG3Inc",
			"MG3Mk1",
			"MG2Mk1",
			"MG1Mk1",
		],
		[
			"Railgun-GattlingTwin",
			"MG5TWINROTARY",
			"MG3Twin",
			"MG3Mk1",
			"MG2Mk1",
			"MG1Mk1",
		],
		[
			"Mortar-GaussInc",
			"Mortar-Incenediary",
			"Mortar-Gauss",
			"Mortar1Mk1",
		],
		[
			"Mortar-GaussInc",
			"Mortar-Gauss",
			"Mortar-Incenediary",
			"Mortar1Mk1",
		],
		];
		
		this.apWeaponsHeavy = [
		[
			"Mortar-GaussRotPlas",
			"Mortar-GaussRot",
			"MortarRotPlas",
			"Mortar3ROTARYMk1",
		],
		];
		
		this.apWeaponsSuper = [
		[
			"Railgun-GattlingAT",
			"Cannon-HPVGattling",
			"Cannon-Gattling",
		],
		[
			"MortarGattlingGauss",
			"MortarGattling",
		],
		];
		
		RATE_AB_LIGHT = 0;	//The Machinegun line lacks any decent anti-structure weapons,
		RATE_AB_MEDIUM = 0;	//so we'll need to rely more on weapons from outside the Machinegun line,
		RATE_AB_HEAVY = 8;	//specifically, the Proto-Railgun, which can only be mounted on heavy tanks.
		RATE_AB_SUPER = 1;
		RATE_AB_SUPER_A = 0;	//There aren't any lightweight turrets to warrant using a standard Proto-Railgun
		RATE_AB_SUPER_B = 1;	//over a pair of fixed-mounted Proto-Railguns.
		
		this.abWeapons = [
		[
		],
		];

		this.abWeaponsLight = [
		[
		],
		];
		
		this.abWeaponsMedium = [
		[
		],
		];
		
		this.abWeaponsHeavy = [
		[
			"Railgun-ProtoTankDest",
		],
		[
			"Mortar-GaussRamjetHvy",
			"Mortar-RamjetHvy",
		],
		];
		
		this.abWeaponsSuper = [
		[
		],
		];
		
		RATE_AA_LIGHT = 1;	//Mini-Rocket Pods, although of the Rockets line, are better than nothing.
		RATE_AA_MEDIUM = 10;	//Machinegun tanks need to be durable in order to take advantage of their high rate-of-fire,
		RATE_AA_HEAVY = 20;	//so we'll build heavy tanks more often.
		RATE_AA_SUPER = 5;
		RATE_AA_SUPER_A = 0;	//No suitable ultra-heavy turrets are available,
		RATE_AA_SUPER_B = 1;	//so all of our ultra-heavy anti-air tanks will mount pairs of heavy AA turrets.
		
		this.aaWeapons = [
		[
			"Railgun-GattlingAA",
			"MG-AA2",
			"MG-AA",
		],
		];

		this.aaWeaponsLight = [
		[
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
		],
		];
		
		this.aaWeaponsMedium = [
		[
			"Railgun-GattlingAALgt",
			"MG-AA2Lgt",
			"MG-AALgt",
		],
		];
		
		this.aaWeaponsHeavy = [
		[
			"Railgun-GattlingAA",
			"MG-AA2",
			"MG-AA",
		],
		];
		
		this.aaWeaponsSuper = [
		[
		],
		];
		
		this.harassWeapons = [
		[
			"SpyTurretNEXUS",
			"SpyTurret03",
			"SpyTurret02",
			"SpyTurret01",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
			"Rocket-BB2",
			"Rocket-BB",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];
	
		this.apCyborgStats = [
		[
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-GattlingInc","HvyCyb-Wpn-Railgun-GattlingInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc","CyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-GattlingInc","HvyCyb-Wpn-Railgun-GattlingInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc","CyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4","HvyCyb-Wpn-MG4","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3","HvyCyb-Wpn-MG3","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-GattlingInc","HvyCyb-Wpn-Railgun-GattlingInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4Inc","HvyCyb-Wpn-MG4Inc","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4","HvyCyb-Wpn-MG4","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3Inc","HvyCyb-Wpn-MG3Inc","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3","HvyCyb-Wpn-MG3","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Mortar-GaussInc","Cyb-Wpn-Mortar-GaussInc","CyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Mortar-Gauss","Cyb-Wpn-Mortar-Gauss","CyborgLegs"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade","CyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Mortar-GaussInc","Cyb-Wpn-Mortar-GaussInc","CyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Mortar-Gauss","Cyb-Wpn-Mortar-Gauss","CyborgLegs"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade","CyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Mortar-GaussInc","Cyb-Wpn-Mortar-GaussInc","CyborgLegs"],
			["Cyb-Bod-Mortar-Gauss","Cyb-Wpn-Mortar-Gauss","CyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade","CyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Mortar-GaussInc","Cyb-Wpn-Mortar-GaussInc","CyborgLegs"],
			["Cyb-Bod-Mortar-Gauss","Cyb-Wpn-Mortar-Gauss","CyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade","CyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		];

		this.atCyborgStats = [
		[
			["HvyCyb-Bod-MG-AntiTankGss","HvyCyb-Wpn-MG-AntiTankGss","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank","HvyCyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Mortar-GaussRamjet","HvyCyb-Wpn-Mortar-GaussRamjet","HvyCyborgLegs"],
			["HvyCyb-Bod-Mortar-Ramjet","HvyCyb-Wpn-Mortar-Ramjet","HvyCyborgLegs"],
		],
		];

		this.abCyborgStats = [ //The Machinegun line lacks any decent anti-structure weapons.
		[
		],
		];

		this.aaCyborgStats = [
		[
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-GattlingInc","HvyCyb-Wpn-Railgun-GattlingInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc","CyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-GattlingInc","HvyCyb-Wpn-Railgun-GattlingInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc","CyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4","HvyCyb-Wpn-MG4","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3","HvyCyb-Wpn-MG3","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-GattlingInc","HvyCyb-Wpn-Railgun-GattlingInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Railgun-Gattling","HvyCyb-Wpn-Railgun-Gattling","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4Inc","HvyCyb-Wpn-MG4Inc","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4","HvyCyb-Wpn-MG4","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3Inc","HvyCyb-Wpn-MG3Inc","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3","HvyCyb-Wpn-MG3","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-MG-AntiTankGss","HvyCyb-Wpn-MG-AntiTankGss","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-MG-AntiTankGss","HvyCyb-Wpn-MG-AntiTankGss","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-MG-AntiTankGss","HvyCyb-Wpn-MG-AntiTankGss","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-MG-AntiTankGss","HvyCyb-Wpn-MG-AntiTankGss","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-MG-AntiTankGss","HvyCyb-Wpn-MG-AntiTankGss","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-MG-AntiTankGss","HvyCyb-Wpn-MG-AntiTankGss","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank2","HvyCyb-Wpn-MG-AntiTank2","HvyCyborgLegs"],
			["HvyCyb-Bod-MG-AntiTank","HvyCyb-Wpn-MG-AntiTank","HvyCyborgLegs"],
		],
		];

		this.vtolBodies = [contingencyBodiesMediumArmored, contingencyBodiesSuperArmored, ];
		this.vtolBodies[0] = this.vtolBodies[0].concat(contingencyBodiesLightArmored);

		this.vtolBodiesLight = [contingencyBodiesLightArmored, ];
		this.vtolBodiesMedium = [contingencyBodiesMediumArmored, ];
		this.vtolBodiesHeavy = [contingencyBodiesHeavyArmored, ];
		this.vtolBodiesSuper = [contingencyBodiesSuperArmored, ];

		this.vtolWeapons = [
		[
			"Bomb-Earthquake",
			"Bomb-FuelAir",
			"Bomb5-VTOL-Plasmite",
			"Bomb4-VTOL-HvyINC",
			"Bomb2-VTOL-HvHE",
			"Bomb3-VTOL-LtINC",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
			"Bomb1-VTOL-LtHE",
			"MG4Inc-VTOL",
			"MG3Inc-VTOL",
		],
		];

		RATE_VTOL_AP_LIGHT = 2;	//The VTOL weapons here tend to have large ammo capacities,
		RATE_VTOL_AP_MEDIUM = 1;	//so the VTOLS will need to be more heavily-armored
		RATE_VTOL_AP_HEAVY = 8;	//to protect them long enough for them to take full advantage of their weapons.
		RATE_VTOL_AP_SUPER = 64;
		RATE_VTOL_AP_SUPER_A = 1;
		RATE_VTOL_AP_SUPER_B = 0;
		
		this.apVtolWeaponsLight = [
		[
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"MG4Inc-VTOL",
			"MG4ROTARY-VTOL",
			"MG3Inc-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		[
			"Railgun-Gattling-VTOL",
			"MG4ROTARY-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		];

		this.apVtolWeaponsMedium = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		this.apVtolWeaponsHeavy = [
		[
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"MG4Inc-VTOL",
			"MG4ROTARY-VTOL",
			"MG3Inc-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		[
			"Railgun-Gattling-VTOL",
			"MG4ROTARY-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		];

		this.apVtolWeaponsSuper = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		RATE_VTOL_AT_LIGHT = 1;	//The VTOL weapons here tend to have large ammo capacities,
		RATE_VTOL_AT_MEDIUM = 16;	//so the VTOLS will need to be more heavily-armored
		RATE_VTOL_AT_HEAVY = 0;	//to protect them long enough for them to take full advantage of their weapons.
		RATE_VTOL_AT_SUPER = 64;
		RATE_VTOL_AT_SUPER_A = 1;
		RATE_VTOL_AT_SUPER_B = 0;
		
		this.atVtolWeaponsLight = [
		[
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"MG4Inc-VTOL",
			"MG4ROTARY-VTOL",
			"MG3Inc-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		[
			"Railgun-Gattling-VTOL",
			"MG4ROTARY-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		];

		this.atVtolWeaponsMedium = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		this.atVtolWeaponsHeavy = [
		[
		],
		];

		this.atVtolWeaponsSuper = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		RATE_VTOL_AB_LIGHT = 1;		//There aren't any dedicated anti-structure weapons here,
		RATE_VTOL_AB_MEDIUM = 16;	//though we may not need them if we're going after base structures.
		RATE_VTOL_AB_HEAVY = 0;
		RATE_VTOL_AB_SUPER = 64;
		RATE_VTOL_AB_SUPER_A = 1;
		RATE_VTOL_AB_SUPER_B = 0;
		
		this.abVtolWeaponsLight = [
		[
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"MG4Inc-VTOL",
			"MG4ROTARY-VTOL",
			"MG3Inc-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		[
			"Railgun-Gattling-VTOL",
			"MG4ROTARY-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		];

		this.abVtolWeaponsMedium = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		this.abVtolWeaponsHeavy = [
		[
		],
		];

		this.abVtolWeaponsSuper = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		RATE_VTOL_AA_LIGHT = 1;	//The anti-air weapons listed here are also listed as anti-personnel and anti-tank weapons.
		RATE_VTOL_AA_MEDIUM = 16;	//Vulcans, Punishers, and Hellfuries are more effective against VTOLs
		RATE_VTOL_AA_HEAVY = 4;	//than Heavy MGs, Assault Guns, and Leadsprayers.
		RATE_VTOL_AA_SUPER = 64;
		RATE_VTOL_AA_SUPER_A = 1;
		RATE_VTOL_AA_SUPER_B = 0;
		
		this.aaVtolWeaponsLight = [
		[
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"MG4Inc-VTOL",
			"MG4ROTARY-VTOL",
			"MG3Inc-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		[
			"Railgun-Gattling-VTOL",
			"MG4ROTARY-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		];

		this.aaVtolWeaponsMedium = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		this.aaVtolWeaponsHeavy = [
		[
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"MG4Inc-VTOL",
			"MG4ROTARY-VTOL",
			"MG3Inc-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		[
			"Railgun-Gattling-VTOL",
			"MG4ROTARY-VTOL",
			"MG3-VTOL",
			"MG2-VTOL",
			"MG1-VTOL",
		],
		];

		this.aaVtolWeaponsSuper = [
		[
			"MG-AntiTankGss-VTOL",
			"MG-AntiTank2-VTOL",
			"MG-AntiTank-VTOL",
		],
		];

		this.defenses = [
		[
			"Bunker3-Railgun-GattlingIncTwin",
			"Bunker3-Railgun-GattlingTwin",
			"Bunker3-MG4IncTwin",
			"Bunker2-MG5",
			"Bunker-MG3IncTwin",
			"Bunker-MG3Twin",
			"PillBox3",
			"PillBox2",
			"PillBox1",
		],
		[
			"Bunker3-Railgun-GattlingTwin",
			"Bunker2-MG5",
			"Bunker-MG3Twin",
			"PillBox3",
			"PillBox2",
			"PillBox1",
		],
		[
			"Bunker4-Railgun-GattlingAT",
			"Bunker3-MG-AntiTankGssTwin",
			"Bunker3-Cannon-HPVGattling",
			"Bunker2-MG-AntiTank2Twin",
			"Bunker2-Cannon-Gattling",
			"Bunker-MG-AntiTankTwin",
			"Bunker-MG-AntiTank",
		],
		[
			"Bunker4-Railgun-GattlingAT",
			"Bunker3-Cannon-HPVGattling",
			"Bunker2-Cannon-Gattling",
			"Bunker3-MG-AntiTankGssTwin",
			"Bunker2-MG-AntiTank2Twin",
			"Bunker-MG-AntiTankTwin",
			"Bunker-MG-AntiTank",
		],
		[
			"Tower3-Railgun-Gattling",
			"Tower-RotMg",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-Railgun-GattlingInc",
			"Tower3-Railgun-Gattling",
			"Tower3-MG4Inc",
			"Tower-RotMg",
			"Tower-MG3Inc",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-Railgun-Gattling",
			"Tower-RotMg",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-Railgun-GattlingInc",
			"Tower3-Railgun-Gattling",
			"Tower3-MG4Inc",
			"Tower-RotMg",
			"Tower-MG3Inc",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Bunker4-Mortar-GaussHvyPlas",
			"Bunker3-MortarHvyPlas",
			"Bunker4-Mortar-GaussHvy",
			"Bunker-MortarHvy",
		],
		[
			"Bunker4-MortarGattlingGauss",
			"Bunker3-MortarGattling",
			"Bunker4-Mortar-GaussRot",
			"Bunker-MortarRot",
		],
		[
			"Bunker4-Mortar-GaussRotPlas",
			"Bunker3-MortarRotPlas",
		],
		[
			"Bunker4-Mortar-GaussRamjetHvy",
			"Bunker3-Mortar-RamjetHvy",
		],
		[
			"Bunker4-Mortar-GaussRamjetRot",
			"Bunker3-Mortar-RamjetRot",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		];

		this.artillery = [
		[
			"Super-MortarGauss-Empl",
			"Super-Mortar-Empl",
			"Bunker2-Howitzer",
			"Bunker-Mortar",
		],
		[
			"Super-HowitzerGauss-Empl",
			"Super-Howitzer-Empl",
			"Emplacement-Howitzer105",
			"Emplacement-MortarPit01",
		],
		];


		this.apArtillery = [
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
			"Emplacement-Rocket06-IDF",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
		],
		[
			"Bunker4-HowitzerGattlingGauss",
			"Bunker3-HowitzerGattling",
			"Bunker4-HowitzerGaussRotPlas",
			"Bunker3-HowitzerRotPlas",
			"Bunker4-HowitzerGaussRot",
			"Bunker2-HowitzerRot",
		],
		[
			"Bunker4-HowitzerGaussRotPlas",
			"Bunker3-HowitzerRotPlas",
			"Bunker4-HowitzerGattlingGauss",
			"Bunker3-HowitzerGattling",
			"Bunker4-HowitzerGaussRot",
			"Bunker2-HowitzerRot",
		],
		[
			"Super-HowitzerGaussPlas-Empl",
			"Super-HowitzerPlas-Empl",
			"Super-HowitzerGauss-Empl",
			"Super-Howitzer-Empl",
		],
		];

		this.atArtillery = [
		[
			"Empl3-TBM-Precision",
		],
		[
			"Empl3-TBM-Precision",
		],
		[
			"Empl3-TBM-Plasmite",
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl3-TBM-Plasmite",
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl4-HowitzerGaussRamjet",
			"Empl3-HowitzerRamjet",
		],
		[
			"Empl4-HowitzerGaussRamjet",
			"Empl3-HowitzerRamjet",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
		],
		[
			"Bunker4-HowitzerGaussRamjetHvy",
			"Bunker3-HowitzerRamjetHvy",
			"Bunker4-HowitzerGaussHvy",
			"Bunker2-HowitzerHvy",
		],
		[
			"Bunker4-HowitzerGaussHvyPlas",
			"Bunker3-HowitzerHvyPlas",
			"Bunker4-HowitzerGaussHvy",
			"Bunker2-HowitzerHvy",
		],
		[
			"Bunker4-HowitzerGaussRamjetRot",
			"Bunker3-HowitzerRamjetRot",
		],
		[
			"Super-HowitzerGaussRamjet-Empl",
			"Super-HowitzerRamjet-Empl",
			"Super-HowitzerGauss-Empl",
			"Super-Howitzer-Empl",
		],
		[
			"Super-HowitzerGaussPlas-Empl",
			"Super-HowitzerPlas-Empl",
		],
		];

		this.abArtillery = [
		[
			"Empl3-TBM-Precision",
		],
		[
			"Empl3-TBM-Earthquake",
		],
		[
			"Bunker4-HowitzerGaussBB",
			"Bunker3-HowitzerBB",
		],
		];


		this.antiair = [
		[
			"Bunker3-Railgun-GattlingAA",
			"Bunker2-MG-AA2",
			"Bunker-MG-AA",
		],
		[
			"Empl3-Railgun-GattlingAALgt",
			"Empl2-MG-AA2Lgt",
			"Empl-MG-AALgt",
		],
		[
			"Empl3-Railgun-GattlingAALgt",
			"Empl2-MG-AA2Lgt",
			"Empl-MG-AALgt",
		],
		];

		this.hardpoints = [
		[
			"WallTower3-Railgun-GattlingIncTwin",
			"WallTower3-Railgun-GattlingTwin",
			"WallTower3-MG4IncTwin",
			"WallTower-TwinAssaultGun",
			"WallTower-MG3IncTwin",
			"WallTower-MG3Twin",
			"WallTower-MG3Inc",
			"WallTower01",
		],
		[
			"WallTower3-Railgun-GattlingTwin",
			"WallTower-TwinAssaultGun",
			"WallTower-MG3Twin",
			"WallTower01",
		],
		[
			"WallTower4-Railgun-GattlingAT",
			"WallTower3-MG-AntiTankGssTwin",
			"WallTower3-Cannon-HPVGattling",
			"WallTower2-MG-AntiTank2Twin",
			"WallTower2-Cannon-Gattling",
			"WallTower-MG-AntiTankTwin",
			"WallTower-MG-AntiTank",
		],
		[
			"WallTower4-Railgun-GattlingAT",
			"WallTower3-Cannon-HPVGattling",
			"WallTower2-Cannon-Gattling",
			"WallTower3-MG-AntiTankGssTwin",
			"WallTower2-MG-AntiTank2Twin",
			"WallTower-MG-AntiTankTwin",
			"WallTower-MG-AntiTank",
		],
		[
			"Tower3-Railgun-Gattling",
			"Tower-RotMg",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-Railgun-GattlingInc",
			"Tower3-Railgun-Gattling",
			"Tower3-MG4Inc",
			"Tower-RotMg",
			"Tower-MG3Inc",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-Railgun-Gattling",
			"Tower-RotMg",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-Railgun-GattlingInc",
			"Tower3-Railgun-Gattling",
			"Tower3-MG4Inc",
			"Tower-RotMg",
			"Tower-MG3Inc",
			"GuardTower3",
			"GuardTower2",
			"GuardTower1",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Tower3-MG-AntiTankGss",
			"Tower2-MG-AntiTank2",
			"Tower-MG-AntiTank",
		],
		[
			"Bunker4-Mortar-GaussHvyPlas",
			"Bunker3-MortarHvyPlas",
			"Bunker4-Mortar-GaussHvy",
			"Bunker-MortarHvy",
		],
		[
			"Bunker4-MortarGattlingGauss",
			"Bunker3-MortarGattling",
			"Bunker4-Mortar-GaussRot",
			"Bunker-MortarRot",
		],
		[
			"Bunker4-Mortar-GaussHvyPlas",
			"Bunker3-MortarHvyPlas",
		],
		[
			"Bunker4-Mortar-GaussRotPlas",
			"Bunker3-MortarRotPlas",
		],
		[
			"Bunker4-Mortar-GaussRamjetHvy",
			"Bunker3-Mortar-RamjetHvy",
		],
		[
			"Bunker4-Mortar-GaussRamjetRot",
			"Bunker3-Mortar-RamjetRot",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Emplacement-MortarEMP",
			"Tower2-EMP-Cannon",
		],
		[
			"Super-RailgunGattlingPlas-Fort",
			"Super-RailgunGattling-Fort",
			"Super-MGPlas-Fort",
			"Super-MG-Fort",
		],
		[
			"Super-RailgunGattling-Fort",
			"Super-MG-Fort",
		],
		[
			"Super-MortarGaussPlas-Empl",
			"Super-MortarPlas-Empl",
			"Super-MortarGaussRamjet-Empl",
			"Super-MortarRamjet-Empl",
			"Super-MortarGauss-Empl",
			"Super-Mortar-Empl",
		],
		[
			"Super-MortarGaussRamjet-Empl",
			"Super-MortarRamjet-Empl",
			"Super-MortarGaussPlas-Empl",
			"Super-MortarPlas-Empl",
			"Super-MortarGauss-Empl",
			"Super-Mortar-Empl",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon1Mk1",
			"R-Vehicle-Prop-Halftracks",
			"R-Struc-PowerModuleMk1",
			"R-Defense-Tower-MG1",
			"R-Vehicle-Prop-Tracks",
			"R-Wpn-MG2Mk1",
			"R-Wpn-MG3Mk1",
			"R-Wpn-Mortar01Lt",
			"R-Wpn-MG-AntiTank",
			"R-Struc-Factory-Module",
			"R-Vehicle-Body05",
			"R-Struc-Factory-Cyborg",
			"R-Wpn-Railgun-ProtoTankDest",		//The Machinegun line lacks a strong anti-structure weapon.
			"R-Sys-Sensor-Tower02",
			"R-Wpn-Rocket06-IDF",
			"R-Defense-Empl2-Rocket-Ripple",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl2-MortarEMP",			//EMP Mortars can be really annoying to deal with.
		];

		this.researchPathFundamental = [
			"R-Vehicle-Prop-Halftracks",
			"R-Struc-RepairFacility",
			"R-Struc-PowerModuleMk1",
			"R-Struc-Factory-Cyborg",
			"R-Struc-WindFarm",
			"R-Vehicle-Prop-Tracks",
			"R-Struc-Power-Upgrade03",
			"R-Vehicle-Engine01",
			"R-Vehicle-Body04",
			"R-Struc-Factory-Module",
			"R-Vehicle-Body05",
			"R-Vehicle-Body11",
			"R-Sys-Spade1Hvy",
			"R-Sys-Sensor-Tower02",
			"R-Vehicle-Body23",
			"R-Struc-VTOLFactory",
			"R-Struc-VTOLPad",
			"R-Sys-RadarDetectorTower2",
			"R-Sys-CBSensor-Tower02",
			"R-Struc-Power-Upgrade06",
			"R-Wpn-MortarEMP",
			"R-Vehicle-Armor-Kinetic03",
			"R-Vehicle-Armor-Heat03",
			"R-Sys-Autorepair-General",
			"R-Vehicle-Body02",
			"R-Vehicle-Engine02",
			"R-Vehicle-Body09",
			"R-Sys-Spade2Hvy",
			"R-Defense-Empl2-MortarEMP",
			"R-Struc-RepairFacility2",
			"R-Sys-Resistance-Upgrade01",
			"R-Vehicle-Body25",
			"R-Struc-Power-Upgrade09",
			"R-Vehicle-Armor-Kinetic06",
			"R-Vehicle-Armor-Heat06",
			"R-Sys-Autorepair-Upgrade01",
			"R-Vehicle-Body20",
			"R-Vehicle-Engine03",
			"R-Vehicle-Body22",
			"R-Sys-Spade3Hvy",
			"R-Struc-RepairFacility3",
			"R-Sys-Resistance-Upgrade02",
			"R-Vehicle-Body27",
			"R-Wpn-LasSat",
			"R-Sys-Sensor-WSTower",
			"R-Sys-Sensor-UpLink",
			"R-Vehicle-Armor-Kinetic09",
			"R-Vehicle-Armor-Heat09",
			"R-Sys-Autorepair-Upgrade02",
			"R-Vehicle-Body15",
			"R-Vehicle-Engine05",
			"R-Vehicle-Body13",
			"R-Sys-Spade4Hvy",
			"R-Struc-RepairFacility4",
			"R-Sys-Resistance-Upgrade03",
		];
		
		this.researchPathAT = [
			"R-Wpn-MG-AntiTank",
			"R-Defense-Tower-MG1",
			"R-Defense-Tower-MG2",
			"R-Defense-Tower-Cannon-Lgt",
			"R-Defense-Tower-MG3",
			"R-Defense-Tower-MG-AntiTank",
			"R-Wpn-MG-AntiTankTwin",
			"R-Defense-Empl-Mortar",
			"R-Defense-Bunker-Cannon-Lgt",
			"R-Defense-Bunker-MG1",
			"R-Defense-Bunker-MG2",
			"R-Defense-Bunker-MG3",
			"R-Defense-Bunker-MG-AntiTank",
			"R-Defense-Bunker-MG3Twin",
			"R-Defense-Bunker-MG-AntiTankTwin",
			"R-Defense-WallTower-Cannon-Lgt",
			"R-Defense-WallTower-MG3",
			"R-Defense-WallTower-MG-AntiTank",
			"R-Defense-WallTower-MG3Twin",
			"R-Defense-WallTower-MG-AntiTankTwin",
			"R-Wpn-MG-AntiTank2Twin",
			"R-Defense-Bunker-MortarHvy",
			"R-Defense-Empl-MortarInc",
			"R-Defense-Tower2-MG4",
			"R-Defense-Tower2-MG-AntiTank2",
			"R-Defense-Empl2-Rocket-Ripple",
			"R-Defense-Bunker2-Rocket-Ripple",
			"R-Sys-Sensor-Tower02",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl2-MortarEMP",			//EMP Mortars can be really annoying to deal with.
			"R-Defense-Bunker2-MG5",
			"R-Defense-Bunker2-MG-AntiTank2Twin",
			"R-Defense-WallTower2-MG5",
			"R-Defense-WallTower2-MG-AntiTank2Twin",
			"R-Defense-Tower3-Railgun-Gattling",
			"R-Defense-Tower3-MG-AntiTankGss",
			"R-Wpn-MG-AntiTankGssTwin",
			"R-Defense-Empl2-Howitzer",
			"R-Defense-Bunker2-HowitzerHvy",
			"R-Defense-Empl3-TBM-FuelAir",
			"R-Defense-Empl3-TBM-Precision",
			"R-Defense-Super-Machinegun",
			"R-Defense-Bunker3-Railgun-GattlingTwin",
			"R-Defense-Bunker3-MG-AntiTankGssTwin",
			"R-Defense-WallTower3-Railgun-GattlingTwin",
			"R-Defense-WallTower3-MG-AntiTankGssTwin",
			"R-Defense-Empl4-HowitzerGauss",
			"R-Defense-Empl4-Mortar-Gauss",
			"R-Defense-Empl4-Mortar-GaussInc",
			"R-Defense-Bunker4-HowitzerGaussHvy",
			"R-Defense-Bunker4-Mortar-GaussHvy",
			"R-Wpn-Artillery-Damage09",
			"R-Wpn-Artillery-ROF09",
			"R-Wpn-Artillery-Accuracy09",
			"R-Wpn-MG-Damage10",
			"R-Wpn-MG-ROF10",
			"R-Wpn-MG-Accuracy10",
			"R-Defense-Bunker2-HowitzerRot",
			"R-Defense-Super-Howitzer",
			"R-Defense-Bunker-MortarRot",
			"R-Defense-Super-Mortar",
			"R-Defense-Bunker4-HowitzerGaussRot",
			"R-Defense-Super-HowitzerGauss",
			"R-Defense-Bunker4-Mortar-GaussRot",
			"R-Defense-Super-MortarGauss",
			"R-Defense-Super-RailgunGattling",
		];
		
		this.researchPathAP = [
			"R-Defense-Tower-MG1",
			"R-Defense-Tower-MG2",
			"R-Wpn-MG3Twin",
			"R-Defense-Tower-MG3",
			"R-Defense-Bunker-MG1",
			"R-Defense-Bunker-MG2",
			"R-Defense-Bunker-MG3",
			"R-Defense-Bunker-MG3Twin",
			"R-Defense-WallTower-MG3",
			"R-Defense-WallTower-MG3Twin",
			"R-Defense-Empl-Mortar",
			"R-Defense-Tower-MG-AntiTank",
			"R-Defense-Bunker-MG-AntiTank",
			"R-Defense-WallTower-MG-AntiTank",
			"R-Defense-Bunker-MG-AntiTankTwin",
			"R-Defense-WallTower-MG-AntiTankTwin",
			"R-Wpn-MG5",
			"R-Defense-Bunker-MortarRot",
			"R-Defense-Empl-MortarInc",
			"R-Defense-Tower2-MG4",
			"R-Defense-Bunker2-MG5",
			"R-Defense-WallTower2-MG5",
			"R-Defense-Tower2-MG-AntiTank2",
			"R-Defense-Bunker2-MG-AntiTank2Twin",
			"R-Defense-WallTower2-MG-AntiTank2Twin",
			"R-Wpn-Railgun-GattlingTwin",
			"R-Defense-Tower3-Railgun-Gattling",
			"R-Defense-Super-Machinegun",
			"R-Defense-Tower3-MG-AntiTankGss",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl4-Mortar-Gauss",
			"R-Defense-Empl4-HowitzerGauss",
			"R-Defense-Empl4-Mortar-GaussInc",
			"R-Defense-Bunker4-Mortar-GaussRot",
			"R-Defense-Bunker4-HowitzerGaussRot",
			"R-Defense-Bunker4-MortarGattlingGauss",
			"R-Defense-Bunker4-HowitzerGattlingGauss",
			"R-Wpn-Artillery-Damage09",
			"R-Wpn-Artillery-ROF09",
			"R-Wpn-Artillery-Accuracy09",
			"R-Wpn-MG-ROF10",
			"R-Wpn-MG-Accuracy10",
			"R-Wpn-MG-Damage10",
			"R-Defense-Bunker3-Railgun-GattlingTwin",
			"R-Defense-Bunker3-MG-AntiTankGssTwin",
			"R-Defense-WallTower3-Railgun-GattlingTwin",
			"R-Defense-WallTower3-MG-AntiTankGssTwin",
			"R-Defense-Bunker2-HowitzerHvy",
			"R-Defense-Super-Howitzer",
			"R-Defense-Bunker-MortarHvy",
			"R-Defense-Super-Mortar",
			"R-Defense-Bunker4-HowitzerGaussHvy",
			"R-Defense-Super-HowitzerGauss",
			"R-Defense-Bunker4-Mortar-GaussHvy",
			"R-Defense-Super-MortarGauss",
			"R-Defense-Super-RailgunGattling",
		];
		
		this.researchPathAA = [
			"R-Defense-Empl-MG-AALgt",
			"R-Defense-Bunker-MG3Twin",
			"R-Defense-Bunker-MG-AA",
			"R-Defense-Empl2-MG-AA2Lgt",
			"R-Defense-Bunker2-MG5",
			"R-Defense-Bunker2-MG-AA2",
			"R-Defense-Empl3-Railgun-GattlingAALgt",
			"R-Defense-Bunker3-Railgun-GattlingTwin",
			"R-Defense-Bunker3-Railgun-GattlingAA",
			"R-Wpn-MG-ROF10",
			"R-Wpn-MG-Damage10",
			"R-Wpn-MG-Accuracy10",
		];
		
		this.researchPathAB = [
			"R-Wpn-Railgun-ProtoTankDest",		//The Machinegun line lacks a strong anti-structure weapon.
			"R-Defense-Empl2-Rocket-Ripple",		//Ripple Rockets are a prerequisite towards researching TBMs.
			"R-Sys-Sensor-Tower02",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl3-TBM-FuelAir",
			"R-Defense-Empl3-TBM-Precision",
			"R-Wpn-LasSat",
			"R-Defense-Empl3-TBM-Earthquake",
			"R-Wpn-Missile-ROF03",
			"R-Defense-Empl-Mortar",			//Just happened to lie close to the path towards researching
			"R-Defense-Empl2-Howitzer",			//the Ground Shaker and Meteor Launcher anti-structure Howitzers.
			"R-Defense-Bunker2-Rocket-Ripple",
			"R-Defense-Bunker2-HowitzerHvy",
			"R-Defense-Bunker3-HowitzerBB",
			"R-Defense-Empl4-Mortar-Gauss",
			"R-Defense-Empl4-HowitzerGauss",
			"R-Defense-Bunker4-HowitzerGaussHvy",
			"R-Defense-Bunker4-HowitzerGaussBB",
			"R-Wpn-Artillery-ROF09",
			"R-Wpn-Artillery-Accuracy09",
			"R-Wpn-Rail-Damage06",				//Save upgrading the Proto-Railgun for last.
			"R-Wpn-Rail-Accuracy06",
			"R-Wpn-Rail-ROF06",
		];

 		//Although the AI will eventually pursue these research items when it has run out of things to pursue,
		//it will also pursue them the moment they become available for direct research.
		this.researchPathExotic = [
			"R-Wpn-HowitzerGaussRamjet",
			"R-Defense-Empl4-HowitzerGaussRamjet",
			"R-Wpn-HowitzerGaussRamjetHvy",
			"R-Defense-Bunker4-HowitzerGaussRamjetHvy",
			"R-Wpn-HowitzerGaussRamjetRot",
			"R-Defense-Bunker4-HowitzerGaussRamjetRot",
			"R-Defense-Super-HowitzerRamjet",
			"R-Defense-Super-HowitzerGaussRamjet",
			"R-Wpn-HowitzerGattlingGauss",
			"R-Defense-Bunker4-HowitzerGattlingGauss",
			"R-Wpn-TBM-Plasmite",
			"R-Defense-Empl3-TBM-Plasmite",
			"R-Wpn-HowitzerGaussInc",
			"R-Defense-Empl4-HowitzerGaussInc",
			"R-Wpn-HowitzerGaussHvyPlas",
			"R-Defense-Bunker4-HowitzerGaussHvyPlas",
			"R-Wpn-HowitzerGaussRotPlas",
			"R-Defense-Bunker4-HowitzerGaussRotPlas",
			"R-Defense-Super-HowitzerPlas",
			"R-Defense-Super-HowitzerGaussPlas",
			"R-Wpn-HowitzerRamjet",
			"R-Defense-Empl3-HowitzerRamjet",
			"R-Wpn-HowitzerRamjetHvy",
			"R-Defense-Bunker3-HowitzerRamjetHvy",
			"R-Wpn-HowitzerRamjetRot",
			"R-Defense-Bunker3-HowitzerRamjetRot",
			"R-Wpn-HowitzerGattling",
			"R-Defense-Bunker3-HowitzerGattling",
			"R-Wpn-Howitzer-Incenediary",
			"R-Defense-Empl2-HowitzerInc",
			"R-Wpn-HowitzerHvyPlas",
			"R-Defense-Bunker3-HowitzerHvyPlas",
			"R-Wpn-HowitzerRotPlas",
			"R-Defense-Bunker3-HowitzerRotPlas",
			"R-Wpn-Mortar-GaussRamjet",
			"R-Defense-Empl4-Mortar-GaussRamjet",
			"R-Wpn-Mortar-GaussRamjetHvy",
			"R-Defense-Bunker4-Mortar-GaussRamjetHvy",
			"R-Wpn-Mortar-GaussRamjetRot",
			"R-Defense-Bunker4-Mortar-GaussRamjetHvy",
			"R-Defense-Super-MortarRamjet",
			"R-Defense-Super-MortarGaussRamjet",
			"R-Wpn-MortarGattlingGauss",
			"R-Defense-Bunker4-MortarGattlingGauss",
			"R-Wpn-Mortar-GaussInc",
			"R-Defense-Empl4-Mortar-GaussInc",
			"R-Wpn-Mortar-GaussHvyPlas",
			"R-Defense-Bunker4-Mortar-GaussHvyPlas",
			"R-Wpn-Mortar-GaussRotPlas",
			"R-Defense-Bunker4-Mortar-GaussRotPlas",
			"R-Defense-Super-MortarPlas",
			"R-Defense-Super-MortarGaussPlas",
			"R-Wpn-Mortar-Ramjet",
			"R-Defense-Empl3-Mortar-Ramjet",
			"R-Wpn-Mortar-RamjetHvy",
			"R-Defense-Bunker3-Mortar-RamjetHvy",
			"R-Wpn-Mortar-RamjetRot",
			"R-Defense-Bunker3-Mortar-RamjetRot",
			"R-Wpn-MortarGattling",
			"R-Defense-Bunker3-MortarGattling",
			"R-Wpn-Mortar-Incenediary",
			"R-Defense-Empl-MortarInc",
			"R-Wpn-MortarHvyPlas",
			"R-Defense-Bunker3-MortarHvyPlas",
			"R-Wpn-MortarRotPlas",
			"R-Defense-Bunker3-MortarRotPlas",
			"R-Wpn-Railgun-GattlingAT",
			"R-Defense-Bunker4-Railgun-GattlingAT",
			"R-Defense-WallTower4-Railgun-GattlingAT",
			"R-Wpn-Rocket-Gattling",
			"R-Defense-Bunker4-Rocket-Gattling",
			"R-Defense-WallTower4-Rocket-Gattling",
			"R-Wpn-Railgun-GattlingInc",
			"R-Defense-Tower3-Railgun-GattlingInc",
			"R-Wpn-Railgun-GattlingIncTwin",
			"R-Defense-Bunker3-Railgun-GattlingIncTwin",
			"R-Defense-WallTower3-Railgun-GattlingIncTwin",
			"R-Defense-Super-MachinegunPlas",
			"R-Defense-Super-RailgunGattlingPlas",
			"R-Wpn-Cannon-HPVGattling",
			"R-Defense-Bunker3-Cannon-HPVGattling",
			"R-Defense-WallTower3-Cannon-HPVGattling",
			"R-Wpn-MG4Inc",
			"R-Defense-Tower3-MG4Inc",
			"R-Wpn-MG4IncTwin",
			"R-Defense-Bunker3-MG4IncTwin",
			"R-Defense-WallTower3-MG4IncTwin",
			"R-Wpn-Cannon-Gattling",
			"R-Defense-Bunker2-Cannon-Gattling",
			"R-Defense-WallTower2-Cannon-Gattling",
			"R-Wpn-MG3Inc",
			"R-Defense-Bunker-MG3Inc",
			"R-Defense-Tower-MG3Inc",
			"R-Wpn-MG3IncTwin",
			"R-Defense-Bunker-MG3IncTwin",
			"R-Defense-WallTower-MG3IncTwin",
		];

	break;
	case 1: //Flamer/Laser Personality

		this.tankBodies = [ contingencyBodiesLightCheap, ];

		this.tankPropulsions = [
		[
			"hover01", // hovers
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		this.apWeapons = [
		[
			"Laser-AP4",
			"Laser-AP3",
			"Laser-AP2",
			"Laser-AP1",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"MG1Mk1",
		],
		[
			"Flamer-PlasmaCannon",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];
		
		this.atWeapons = [
		[
			"Laser-AT4",
			"Laser-AT3",
			"Laser-AT2",
			"Laser-AT1",
			"PlasmiteFlamer",
			"Flame2",
			"Cannon1Mk1",
			"Flame1Mk1",
			"MG1Mk1",
		],
		[
			"Laser-TankDest2",
			"Laser-TankDest",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Flamer-PlasCan-TankDest",
			"PlasmiteFlamer",
			"Flame2",
			"Flame1Mk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];

		this.abWeapons = [
		[
			"Laser-Sonic-TankDest",
			"Laser-Sonic",
		],
		];
		
		this.aaWeapons = [
		[
			"Laser-AA2",
			"Laser-AA",
			"MG-AA2",
			"MG-AA",
		],
		];
		
		this.apCyborgStats = [
		[
			["Cyb-Bod-Laser-AP3","Cyb-Wpn-Laser-AP3","CyborgLegs"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc","CyborgLegs"],
			["Cyb-Bod-Laser-AP1","Cyb-Wpn-Laser-AP1","CyborgLegs"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc","CyborgLegs"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite","CyborgLegs"],
			["CyborgFlamerGrd","CyborgFlamer01","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Laser-AP3","HvyCyb-Wpn-Laser-AP3","HvyCyborgLegs"],
			["HvyCyb-Bod-Flamer3","HvyCyb-Wpn-Flamer3","HvyCyborgLegs"],
			["HvyCyb-Bod-Laser-AP1","HvyCyb-Wpn-Laser-AP1","HvyCyborgLegs"],
			["HvyCyb-Bod-Flamer2","HvyCyb-Wpn-Flamer2","HvyCyborgLegs"],
			["HvyCyb-Bod-Flamer1","HvyCyb-Wpn-Flamer1","HvyCyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["Cyb-Bod-Laser-AP3","Cyb-Wpn-Laser-AP3","CyborgLegs"],
			["HvyCyb-Bod-Laser-AP1","HvyCyb-Wpn-Laser-AP1","HvyCyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite","CyborgLegs"],
			["CyborgFlamerGrd","CyborgFlamer01","CyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
		],
		];

		this.atCyborgStats = [
		[
			["HvyCyb-Bod-Laser-AT3","HvyCyb-Wpn-Laser-AT3","HvyCyborgLegs"],
			["HvyCyb-Bod-Laser-AT1","HvyCyb-Wpn-Laser-AT1","HvyCyborgLegs"],
			["HvyCyb-Bod-Flamer3","HvyCyb-Wpn-Flamer3","HvyCyborgLegs"],
			["HvyCyb-Bod-Flamer2","HvyCyb-Wpn-Flamer2","HvyCyborgLegs"],
			["HvyCyb-Bod-Flamer1","HvyCyb-Wpn-Flamer1","HvyCyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
		],
		[
			["Cyb-Bod-Laser-AT3","Cyb-Wpn-Laser-AT3","CyborgLegs"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite","CyborgLegs"],
			["Cyb-Bod-Laser-AT1","Cyb-Wpn-Laser-AT1","CyborgLegs"],
			["CyborgFlamerGrd","CyborgFlamer01","CyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Laser-AT3","HvyCyb-Wpn-Laser-AT3","HvyCyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Thermite","Cyb-Wpn-Thermite","CyborgLegs"],
			["Cyb-Bod-Laser-AT1","Cyb-Wpn-Laser-AT1","CyborgLegs"],
			["CyborgFlamerGrd","CyborgFlamer01","CyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
		],
		];
		
		this.aaCyborgStats = [
		[
			["Cyb-Bod-Laser-AP3","Cyb-Wpn-Laser-AP3","CyborgLegs"],
			["Cyb-Bod-MG4Inc","Cyb-Wpn-MG4Inc","CyborgLegs"],
			["Cyb-Bod-Laser-AP1","Cyb-Wpn-Laser-AP1","CyborgLegs"],
			["Cyb-Bod-MG3Inc","Cyb-Wpn-MG3Inc","CyborgLegs"],
			["CybRotMgGrd","CyborgRotMG","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Laser-AP3","HvyCyb-Wpn-Laser-AP3","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4Inc","HvyCyb-Wpn-MG4Inc","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3Inc","HvyCyb-Wpn-MG3Inc","HvyCyborgLegs"],
			["HvyCyb-Bod-Laser-AP1","HvyCyb-Wpn-Laser-AP1","HvyCyborgLegs"],
			["HvyCyb-Bod-MG4","HvyCyb-Wpn-MG4","HvyCyborgLegs"],
			["HvyCyb-Bod-MG3","HvyCyb-Wpn-MG3","HvyCyborgLegs"],
		],
		];

		this.vtolBodies = [contingencyBodiesVtol,];

		this.vtolWeapons = [
		[
			"Bomb-Earthquake",
			"Bomb-FuelAir",
			"Bomb5-VTOL-Plasmite",
			"Bomb4-VTOL-HvyINC",
			"Bomb2-VTOL-HvHE",
			"Bomb3-VTOL-LtINC",
			"Bomb1-VTOL-LtHE",
		],
		];

		this.defenses = [
		[
			"Tower3-Laser-AP3",
			"Tower2-Laser-AP1",
		],
		[
			"Bunker3-Laser-AP4",
			"Bunker3-Laser-AP3",
			"Bunker2-Laser-AP2",
			"Bunker2-Laser-AP1",
		],
		[
			"Bunker3-Laser-AT4",
			"Bunker3-Laser-AT3",
			"Bunker2-Laser-AT2",
			"Bunker2-Laser-AT1",
		],
		[
			"Tower3-Laser-AT3",
			"Tower2-Laser-AT1",
		],
		[
			"Super-Laser2-Fort",
			"Super-Laser-Fort",
		],
		];

		this.artillery = [
		[
			"Bunker2-HowitzerInc",
			"Bunker2-Howitzer",
			"Bunker-MortarInc",
			"Bunker-Mortar",
		],
		[
			"Emplacement-Howitzer-Incenediary",
			"Emplacement-Howitzer105",
			"Emplacement-MortarPit-Incenediary",
			"Emplacement-MortarPit01",
		],
		[
			"Super-HowitzerPlas-Empl",
			"Super-Howitzer-Empl",
			"Super-MortarPlas-Empl",
			"Super-Mortar-Empl",
		],
		];

		this.antiair = [
		[
			"WallTower3-Laser-AA2",
			"WallTower-Laser-AA",
			"WallTower2-MG-AA2",
			"WallTower-MG-AA",
		],
		];

		this.hardpoints = [
		[
			"WallTower3-Laser-AP4",
			"WallTower3-Laser-AP3",
			"WallTower2-Laser-AP2",
			"WallTower2-Laser-AP1",
		],
		[
			"WallTower3-Laser-AT4",
			"WallTower3-Laser-AT3",
			"WallTower2-Laser-AT2",
			"WallTower2-Laser-AT1",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon-Damage01",
			"R-Vehicle-Prop-Halftracks",
			"R-Wpn-Flamer-ROF01",
			"R-Struc-PowerModuleMk1",
			"R-Struc-Factory-Cyborg",
			"R-Vehicle-Body04",
			"R-Vehicle-Prop-Halftracks",
			"R-Wpn-Flame2",
			"R-Defense-Empl-MortarInc",
			"R-Struc-Research-Upgrade05",
			"R-Struc-PowerModuleMk1",
			"R-Wpn-Plasmite-Flamer",
		];
		
		this.researchPathAT = [
			"R-Wpn-Flamer-PlasCan-TankDest",
			"R-Defense-Bunker2-Laser-AT1",
			"R-Defense-Tower2-Laser-AT1",
			"R-Defense-WallTower2-Laser-AT1",
			"R-Defense-Bunker2-Laser-AT2",
			"R-Defense-WallTower2-Laser-AT2",
			"R-Defense-Bunker3-Laser-AT3",
			"R-Defense-Tower3-Laser-AT3",
			"R-Defense-WallTower3-Laser-AT3",
			"R-Defense-Bunker3-Laser-AT4",
			"R-Defense-WallTower3-Laser-AT4",
			"R-Defense-Super-Laser",
		];
		
		this.researchPathAP = [
			"R-Wpn-Flamer-PlasmaCannon",
			"R-Defense-Bunker2-Laser-AP1",
			"R-Defense-Tower2-Laser-AP1",
			"R-Defense-WallTower2-Laser-AP1",
			"R-Defense-Bunker2-Laser-AP2",
			"R-Defense-WallTower2-Laser-AP2",
			"R-Defense-Bunker3-Laser-AP3",
			"R-Defense-Tower3-Laser-AP3",
			"R-Defense-WallTower3-Laser-AP3",
			"R-Defense-Bunker3-Laser-AP4",
			"R-Defense-WallTower3-Laser-AP4",
			"R-Defense-Super-Laser",
		];
		
		this.researchPathAA = [
			"R-Defense-WallTower-MG-AA",
			"R-Defense-WallTower2-MG-AA2",
			"R-Defense-WallTower-Laser-AA",
			"R-Defense-WallTower3-Laser-AA2",
		];
		
		this.researchPathAB = [
			"R-Defense-Empl-MortarInc",
			"R-Defense-Super-MortarPlas",
			"R-Defense-Empl2-HowitzerInc",
			"R-Defense-Super-HowitzerPlas",
			"R-Wpn-Bomb-Earthquake",
			"R-Wpn-Laser-Sonic-TankDest",
		];

	break;
	case 2: //Cannon Personality

		this.tankBodies = [contingencyBodiesSuperArmored,];
		this.tankBodies[0] = this.tankBodies[0].concat(contingencyBodiesHeavyArmored,contingencyBodiesMediumArmored,contingencyBodiesLightArmored);
	
		this.tankBodiesLight = [contingencyBodiesLightArmored,];
		this.tankBodiesMedium = [contingencyBodiesMediumArmored,];
		this.tankBodiesHeavy = [contingencyBodiesHeavyArmored,];
		this.tankBodiesSuper = [contingencyBodiesSuperArmored,];
		
		sensorBodies = contingencyBodiesHeavyArmored;
		empBodies = contingencyBodiesMediumArmored;

		this.tankPropulsions = [
		[
			"tracked01", // tracks
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		sensorPropulsions = this.tankPropulsions[0];
		empPropulsions = this.tankPropulsions[0];

		RATE_AT_LIGHT = 16;	//Tankbuster Cannons have incredible damage-per-shot for their price and weight,
		RATE_AT_MEDIUM = 4;	//so we'll be building more light anti-tank vehicles than usual
		RATE_AT_HEAVY = 2;	//to minimize the impact of the Tankbuster Cannons' low rate-of-fire.
		RATE_AT_SUPER = 1;
		RATE_AT_SUPER_A = 1;	//Not many good choices for ultra-heavy turrets,
		RATE_AT_SUPER_B = 4;	//so we'll just build more ultra-heavy tanks with 2 heavy turrets.
		
		this.atWeapons = [
		[
			"Railgun-GattlingAT",
			"Railgun-TankDest",
			"Railgun-Aslt",
			"Railgun-ProtoTankDest",
			"Railgun-Proto",
			"Cannon-HPVGattling",
			"Cannon-HPVHvy",
			"Cannon-HPVTwinAslt",
			"Cannon-HPVTankDest",
			"Cannon-HPVAslt",
			"Cannon-TankDest",
			"Cannon4AUTOMk1",
			"Cannon-HPVLgt",
			"Cannon2A-TMk1",
			"Cannon1Mk1",
		],
		];
		
		this.atWeaponsLight = [
		[
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"Railgun-TankDestLgt",
			"Cannon-HPVTankDestLgt",
			"Cannon-TankDestLgt",
		],
		[
			"Railgun-TankDestLgt",
			"Cannon-HPVTankDestLgt",
			"Cannon-TankDestLgt",
		],
		[
			"Railgun-TankDestLgt",
			"Cannon-HPVTankDestLgt",
			"Cannon-TankDestLgt",
		],
		];
		
		this.atWeaponsMedium = [
		[
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"Railgun-TankDest",
			"Cannon-HPVTankDest",
			"Cannon-TankDest",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"Railgun-TankDest",
			"Cannon-HPVTankDest",
			"Cannon-TankDest",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"Railgun-TankDest",
			"Cannon-HPVTankDest",
			"Cannon-TankDest",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"Railgun-TankDest",
			"Cannon-HPVTankDest",
			"Cannon-TankDest",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"Cannon-PlasTankDest",
			"Cannon-IncTankDest",
		],
		[
			"Mortar-GaussRamjet",
			"Mortar-Ramjet",
		],
		[
			"Mortar-GaussRamjet",
			"Mortar-Ramjet",
		],
		[
			"Mortar-GaussInc",
			"Mortar-Incenediary",
		],
		];
		
		this.atWeaponsHeavy = [
		[
			"Cannon-Ramjet-TankDest",
			"RailGun3Mk1",
			"Cannon-HPVHvy",
			"Cannon375mmMk1",
			"Railgun-ProtoTankDest",
			"Railgun-TwinAslt",
			"Cannon-HPVTwinAslt",
			"Cannon6TwinAslt",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"Railgun-TwinAslt",
			"Cannon-HPVTwinAslt",
			"Cannon6TwinAslt",
			"RailGun3Mk1",
			"Cannon-HPVHvy",
			"Cannon375mmMk1",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"RailGun3Mk1",
			"Cannon-HPVHvy",
			"Cannon375mmMk1",
			"Railgun-TwinAslt",
			"Cannon-HPVTwinAslt",
			"Cannon6TwinAslt",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
		],
		[
			"Cannon-Plas",
			"Cannon-Inc",
		],
		[
			"Flamer-PlasCan-TankDest",
		],
		[
			"Mortar-GaussHvyPlas",
			"MortarHvyPlas",
		],
		[
			"Mortar-GaussHvy",
			"Mortar2Mk1",
		],
		[
			"Mortar-GaussRamjetRot",
			"Mortar-RamjetRot",
		],
		[
			"Mortar-GaussRamjetHvy",
			"Mortar-RamjetHvy",
		],
		];
		
		this.atWeaponsSuper = [
		[
			"Railgun-GattlingAT",
			"Cannon-HPVGattling",
			"Cannon-Gattling",
		],
		[
			"Cannon-Ramjet",
			"Railgun-Proto",
		],
		[
			"Flamer-PlasmaCannon",
		],
		];
		
		RATE_AP_LIGHT = 1;	//Not many good anti-personnel weapons to choose from for light tanks to mount.
		RATE_AP_MEDIUM = 16;	//Blunderbuss, Scattershot, and mortars are probably some of the best anti-personnel weapons to use.
		RATE_AP_HEAVY = 4;	//We need our rapid-firing Twin Assault Cannon tanks to be durable enough for it to count,
		RATE_AP_SUPER = 4;	//so we'll be building larger, heavily-armored anti-personnel vehicles more frequently.
		RATE_AP_SUPER_A = 2;	//Incendiary Cannons, Incendiary Mortars, and Gattling Mortars
		RATE_AP_SUPER_B = 2;	//are equally viable choices.
		
		this.apWeapons = [
		[
			"Railgun-GattlingTwin",
			"Railgun-Shotgun",
			"Railgun-Gattling",
			"Railgun-TwinAslt",
			"Railgun-Proto",
			"Cannon-Shotgun",
			"Cannon-Gattling",
			"Cannon6TwinAslt",
			"Cannon375mmMk1",
			"Cannon5VulcanMk1",
			"Cannon2A-TMk1",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];
		
		this.apWeaponsLight = [
		[
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];
		
		this.apWeaponsMedium = [
		[
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Railgun-Shotgun",
			"Cannon-Shotgun",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Railgun-Shotgun",
			"Cannon-Shotgun",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Mortar-GaussInc",
			"Mortar-Incenediary",
			"Mortar-Gauss",
			"Mortar1Mk1",
		],
		[
			"Mortar-GaussInc",
			"Mortar-Gauss",
			"Mortar-Incenediary",
			"Mortar1Mk1",
		],
		];
		
		this.apWeaponsHeavy = [
		[
			"Railgun-TwinAslt",
			"Cannon-HPVTwinAslt",
			"Cannon6TwinAslt",
			"Railgun-Shotgun",
			"Cannon-Shotgun",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun3Mk1",
			"Cannon-HPVHvy",
			"Cannon375mmMk1",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Cannon-Plas",
			"Cannon-Inc",
			"Railgun-TwinAslt",
			"Cannon-HPVTwinAslt",
			"Cannon6TwinAslt",
			"Railgun-Shotgun",
			"Cannon-Shotgun",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun3Mk1",
			"Cannon-HPVHvy",
			"Cannon375mmMk1",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Flamer-PlasCan-TankDest",
			"Cannon-Plas",
			"Cannon-Inc",
			"Railgun-TwinAslt",
			"Cannon-HPVTwinAslt",
			"Cannon6TwinAslt",
			"Railgun-Shotgun",
			"Cannon-Shotgun",
			"Railgun-Aslt",
			"Cannon-HPVAslt",
			"Cannon5VulcanMk1",
			"RailGun3Mk1",
			"Cannon-HPVHvy",
			"Cannon375mmMk1",
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
			"Cannon2A-TMk1",
			"RailGun1Mk1",
			"Cannon-HPVLgt",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Mortar-GaussRotPlas",
			"MortarRotPlas",
			"Mortar-GaussRot",
			"Mortar3ROTARYMk1",
		],
		[
			"Mortar-GaussRotPlas",
			"Mortar-GaussRot",
			"MortarRotPlas",
			"Mortar3ROTARYMk1",
		],
		];
		
		this.apWeaponsSuper = [
		[
			"Railgun-GattlingAT",
			"Cannon-HPVGattling",
			"Cannon-Gattling",
		],
		[
			"Railgun-GattlingAT",
			"Cannon-HPVGattling",
			"Cannon-Gattling",
		],
		[
			"Flamer-PlasmaCannon",
		],
		[
			"MortarGattlingGauss",
			"MortarGattling",
		],
		[
			"MortarGattlingGauss",
			"MortarGattling",
		],
		];
		
		RATE_AB_LIGHT = 24;	//Tankbuster Cannons have incredible damage-per-shot for their price and weight.
		RATE_AB_MEDIUM = 1;	//Not a whole lot of good choices here.
		RATE_AB_HEAVY = 8;	//Proto-Railguns are probably the best anti-structure weapons available,
		RATE_AB_SUPER = 2;	//so we'll need more heavy tanks that can mount them.
		RATE_AB_SUPER_A = 1;	//Two Fixed-Mounted Proto-Railguns would probably be better
		RATE_AB_SUPER_B = 4;	//than a single Proto-Railgun paired with a Tankbuster Cannon.
		
		this.abWeapons = [
		[
		],
		];

		this.abWeaponsLight = [
		[
			"Railgun-TankDestLgt",
			"Cannon-HPVTankDestLgt",
		],
		];
		
		this.abWeaponsMedium = [
		[
			"RailGun2Mk1",
			"Cannon4AUTOMk1",
		],
		[
			"Railgun-TankDest",
			"Cannon-HPVTankDest",
		],
		[
			"Railgun-TankDest",
			"Cannon-HPVTankDest",
		],
		[
			"Railgun-TankDest",
			"Cannon-HPVTankDest",
		],
		];
		
		this.abWeaponsHeavy = [
		[
			"Railgun-ProtoTankDest",
			"Cannon-Ramjet-TankDest",
		],
		[
			"Railgun-ProtoTankDest",
			"Cannon-Ramjet-TankDest",
		],
		[
			"Railgun-ProtoTankDest",
			"Cannon-Ramjet-TankDest",
		],
		[
			"RailGun3Mk1",
			"Cannon-HPVHvy",
		],
		[
			"Mortar-GaussRamjetHvy",
			"Mortar-RamjetHvy",
		],
		[
			"Mortar-GaussRamjetHvy",
			"Mortar-RamjetHvy",
		],
		];
		
		this.abWeaponsSuper = [
		[
			"Railgun-Proto",
			"Cannon-Ramjet",
		],
		];
		
		RATE_AA_LIGHT = 1;	//Mini-Rocket Pods, although of the Rockets line, are better than nothing.
		RATE_AA_MEDIUM = 0;	//No suitable turrets are available for this weight class.
		RATE_AA_HEAVY = 20;	//The only dedicated anti-air weapons available require heavy bodies to mount them.
		RATE_AA_SUPER = 5;
		RATE_AA_SUPER_A = 0;	//No suitable ultra-heavy turrets are available,
		RATE_AA_SUPER_B = 1;	//so all of our ultra-heavy anti-air tanks will mount pairs of Flak Cannon turrets.
		
		this.aaWeapons = [
		[
			"Railgun-GattlingAA",
			"Railgun-Flak",
			"AAGun2Mk1",
		],
		];
		
		this.aaWeaponsLight = [
		[
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
		],
		];
		
		this.aaWeaponsMedium = [
		[
		],
		];
		
		this.aaWeaponsHeavy = [
		[
			"Railgun-Flak",
			"AAGun2Mk1",
		],
		];
		
		this.aaWeaponsSuper = [
		[
		],
		];
		
		this.harassWeapons = [
		[
			"SpyTurretNEXUS",
			"SpyTurret03",
			"SpyTurret02",
			"SpyTurret01",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
			"Rocket-BB2",
			"Rocket-BB",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];
	
		this.atCyborgStats = [
		[
			["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","HvyCyborgLegs"],
			["Cyb-Hvybod-HPV","Cyb-Hvywpn-HPV","HvyCyborgLegs"],
			["Cyb-Hvybod-Mcannon","Cyb-Hvywpn-Mcannon","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod","HvyCyborgLegs"],
		],
		[
			["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","HvyCyborgLegs"],
			["Cyb-Hvybod-HPV","Cyb-Hvywpn-HPV","HvyCyborgLegs"],
			["Cyb-Hvybod-Mcannon","Cyb-Hvywpn-Mcannon","HvyCyborgLegs"],
		],
		[
			["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","HvyCyborgLegs"],
			["Cyb-Hvybod-HPV","Cyb-Hvywpn-HPV","HvyCyborgLegs"],
			["Cyb-Hvybod-Mcannon","Cyb-Hvywpn-Mcannon","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"],
			["Cyb-Bod-Cannon-HPVLgt","Cyb-Wpn-Cannon-HPVLgt","CyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Mortar-GaussRamjet","HvyCyb-Wpn-Mortar-GaussRamjet","HvyCyborgLegs"],
			["HvyCyb-Bod-Mortar-Ramjet","HvyCyb-Wpn-Mortar-Ramjet","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-Mortar-GaussRamjet","HvyCyb-Wpn-Mortar-GaussRamjet","HvyCyborgLegs"],
			["HvyCyb-Bod-Mortar-Ramjet","HvyCyb-Wpn-Mortar-Ramjet","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-Mortar-GaussRamjet","HvyCyb-Wpn-Mortar-GaussRamjet","HvyCyborgLegs"],
			["HvyCyb-Bod-Mortar-Ramjet","HvyCyb-Wpn-Mortar-Ramjet","HvyCyborgLegs"],
		],
		];
		
		this.apCyborgStats = [
		[
			["Cyb-Bod-Railgun-Sniper","Cyb-Wpn-Railgun-Sniper","CyborgLegs"],
			["Cyb-Bod-Cannon-Sniper","Cyb-Wpn-Cannon-Sniper","CyborgLegs"],
		],
		[
			["Cyb-Bod-Railgun-Sniper","Cyb-Wpn-Railgun-Sniper","CyborgLegs"],
			["Cyb-Bod-Cannon-Sniper","Cyb-Wpn-Cannon-Sniper","CyborgLegs"],
		],
		[
			["Cyb-Bod-Railgun-Sniper","Cyb-Wpn-Railgun-Sniper","CyborgLegs"],
			["Cyb-Bod-Cannon-Sniper","Cyb-Wpn-Cannon-Sniper","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Railgun-Shotgun","HvyCyb-Wpn-Railgun-Shotgun","HvyCyborgLegs"],
			["HvyCyb-Bod-Cannon-Shotgun","HvyCyb-Wpn-Cannon-Shotgun","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Rail1","Cyb-Wpn-Rail1","CyborgLegs"],
			["Cyb-Bod-Cannon-HPVLgt","Cyb-Wpn-Cannon-HPVLgt","CyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["Cyb-Bod-Mortar-GaussInc","Cyb-Wpn-Mortar-GaussInc","CyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Mortar-Gauss","Cyb-Wpn-Mortar-Gauss","CyborgLegs"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade","CyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Mortar-GaussInc","Cyb-Wpn-Mortar-GaussInc","CyborgLegs"],
			["Cyb-Bod-Mortar-Gauss","Cyb-Wpn-Mortar-Gauss","CyborgLegs"],
			["Cyb-Bod-MortarInc","Cyb-Wpn-MortarInc","CyborgLegs"],
			["Cyb-Bod-Grenade","Cyb-Wpn-Grenade","CyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		];

		this.abCyborgStats = [
		[
			["Cyb-Hvybod-RailGunner","Cyb-Hvywpn-RailGunner","HvyCyborgLegs"],
			["Cyb-Hvybod-HPV","Cyb-Hvywpn-HPV","HvyCyborgLegs"],
		],
		];

		this.aaCyborgStats = [
		[
			["HvyCyb-Bod-Railgun-Shotgun","HvyCyb-Wpn-Railgun-Shotgun","HvyCyborgLegs"],
			["HvyCyb-Bod-Cannon-Shotgun","HvyCyb-Wpn-Cannon-Shotgun","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod","HvyCyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		];

		this.vtolBodies = [contingencyBodiesMediumArmored, contingencyBodiesSuperArmored, ];
		this.vtolBodies[0] = this.vtolBodies[0].concat(contingencyBodiesLightArmored);

		this.vtolBodiesLight = [contingencyBodiesLightArmored, ];
		this.vtolBodiesMedium = [contingencyBodiesMediumArmored, ];
		this.vtolBodiesHeavy = [contingencyBodiesHeavyArmored, ];
		this.vtolBodiesSuper = [contingencyBodiesSuperArmored, ];

		this.vtolWeapons = [
		[
			"Bomb-Earthquake",
			"Railgun-GattlingInc-VTOL",
			"Railgun-Gattling-VTOL",
			"Railgun-Aslt-VTOL",
			"Bomb-FuelAir",
			"Bomb5-VTOL-Plasmite",
			"Railgun-Shotgun-VTOL",
			"Bomb4-VTOL-HvyINC",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"Bomb2-VTOL-HvHE",
			"Cannon4AUTO-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon-Med-VTOL",
			"Bomb3-VTOL-LtINC",
			"Bomb1-VTOL-LtHE",
			"Cannon-Shotgun-VTOL",
			"Cannon1-VTOL",
		],
		];

		RATE_VTOL_AP_LIGHT = 1;		//The VTOL weapons here tend to have large ammo capacities,
		RATE_VTOL_AP_MEDIUM = 16;	//so the VTOLS will need to be more heavily-armored
		RATE_VTOL_AP_HEAVY = 4;		//to protect them long enough for them to take full advantage of their weapons.
		RATE_VTOL_AP_SUPER = 64;
		RATE_VTOL_AP_SUPER_A = 1;
		RATE_VTOL_AP_SUPER_B = 0;
		
		this.apVtolWeaponsLight = [
		[
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.apVtolWeaponsMedium = [
		[
			"Railgun-Shotgun-VTOL",
			"Cannon-Shotgun-VTOL",
			"Railgun-Aslt-VTOL",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"RailGun2-VTOL",
			"Cannon4AUTO-VTOL",
			"Cannon-Med-VTOL",
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.apVtolWeaponsHeavy = [
		[
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.apVtolWeaponsSuper = [
		[
			"Railgun-Shotgun-VTOL",
			"Cannon-Shotgun-VTOL",
			"Railgun-Aslt-VTOL",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"RailGun2-VTOL",
			"Cannon4AUTO-VTOL",
			"Cannon-Med-VTOL",
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		RATE_VTOL_AT_LIGHT = 1;		//The VTOL weapons here tend to have large ammo capacities,
		RATE_VTOL_AT_MEDIUM = 16;	//so the VTOLS will need to be more heavily-armored
		RATE_VTOL_AT_HEAVY = 4;		//to protect them long enough for them to take full advantage of their weapons.
		RATE_VTOL_AT_SUPER = 64;
		RATE_VTOL_AT_SUPER_A = 1;
		RATE_VTOL_AT_SUPER_B = 0;
		
		this.atVtolWeaponsLight = [
		[
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.atVtolWeaponsMedium = [
		[
			"RailGun2-VTOL",
			"Cannon4AUTO-VTOL",
			"Cannon-Med-VTOL",
			"Railgun-Aslt-VTOL",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.atVtolWeaponsHeavy = [
		[
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.atVtolWeaponsSuper = [
		[
			"RailGun2-VTOL",
			"Cannon4AUTO-VTOL",
			"Cannon-Med-VTOL",
			"Railgun-Aslt-VTOL",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		RATE_VTOL_AB_LIGHT = 1;		//Although we lack a dedicated anti-structure weapon for VTOLs,
		RATE_VTOL_AB_MEDIUM = 16;	//we may not need one if we're attacking base structures.
		RATE_VTOL_AB_HEAVY = 4;
		RATE_VTOL_AB_SUPER = 64;
		RATE_VTOL_AB_SUPER_A = 1;
		RATE_VTOL_AB_SUPER_B = 0;
		
		this.abVtolWeaponsLight = [
		[
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.abVtolWeaponsMedium = [
		[
			"RailGun2-VTOL",
			"Cannon4AUTO-VTOL",
			"Cannon-Med-VTOL",
			"Railgun-Aslt-VTOL",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.abVtolWeaponsHeavy = [
		[
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		this.abVtolWeaponsSuper = [
		[
			"RailGun2-VTOL",
			"Cannon4AUTO-VTOL",
			"Cannon-Med-VTOL",
			"Railgun-Aslt-VTOL",
			"Cannon-HPVAslt-VTOL",
			"Cannon5Vulcan-VTOL",
			"RailGun1-VTOL",
			"Cannon-HPVLgt-VTOL",
			"Cannon1-VTOL",
		],
		];

		RATE_VTOL_AA_LIGHT = 8;	//The only anti-air weapons available are the Blunderbuss and Scattershot.
		RATE_VTOL_AA_MEDIUM = 4;	//Although they're too heavy for use on a light or heavy VTOL,
		RATE_VTOL_AA_HEAVY = 2;	//we won't need speed when defending our base.
		RATE_VTOL_AA_SUPER = 1;
		RATE_VTOL_AA_SUPER_A = 1;
		RATE_VTOL_AA_SUPER_B = 0;
		
		this.aaVtolWeaponsLight = [
		[
			"Railgun-Shotgun-VTOL",
			"Cannon-Shotgun-VTOL",
			"Rocket-VTOL-Pod",
		],
		];

		this.aaVtolWeaponsMedium = [
		[
			"Railgun-Shotgun-VTOL",
			"Cannon-Shotgun-VTOL",
		],
		];

		this.aaVtolWeaponsHeavy = [
		[
			"Railgun-Shotgun-VTOL",
			"Cannon-Shotgun-VTOL",
		],
		];

		this.aaVtolWeaponsSuper = [
		[
			"Railgun-Shotgun-VTOL",
			"Cannon-Shotgun-VTOL",
		],
		];

		this.defenses = [
		[
			"Bunker3-Cannon-Ramjet",
			"Bunker3-Railgun-Hvy",
			"Bunker2-Cannon-HPVHvy",
			"Bunker-Cannon-Hvy",
			"Bunker-Railgun-Proto",
			"Bunker3-Railgun-Med",
			"Bunker2-Cannon-HPVMed",
			"Bunker-Cannon-Med",
			"Bunker4-Railgun-GattlingAT",
			"Bunker3-Cannon-HPVGattling",
			"Bunker2-Cannon-Gattling",
			"Bunker3-Railgun-TwinAslt",
			"Bunker2-Cannon-HPVTwinAslt",
			"PillBox-Cannon6",
			"Bunker3-Railgun-Aslt",
			"Bunker2-Cannon-HPVAslt",
			"Bunker-Cannon-Aslt",
			"Bunker3-Railgun-Lgt",
			"Bunker2-Cannon-HPVLgt",
			"PillBox4",
		],
		[
			"Bunker4-Railgun-GattlingAT",
			"Bunker3-Cannon-HPVGattling",
			"Bunker2-Cannon-Gattling",
			"Bunker3-Railgun-TwinAslt",
			"Bunker2-Cannon-HPVTwinAslt",
			"PillBox-Cannon6",
			"Bunker3-Railgun-Aslt",
			"Bunker2-Cannon-HPVAslt",
			"Bunker-Cannon-Aslt",
			"Bunker3-Cannon-Ramjet",
			"Bunker3-Railgun-Hvy",
			"Bunker2-Cannon-HPVHvy",
			"Bunker-Cannon-Hvy",
			"Bunker-Railgun-Proto",
			"Bunker3-Railgun-Med",
			"Bunker2-Cannon-HPVMed",
			"Bunker-Cannon-Med",
			"Bunker3-Railgun-Lgt",
			"Bunker2-Cannon-HPVLgt",
			"PillBox4",
		],
		[
			"Bunker4-Flamer-PlasmaCannon",
			"Bunker3-Cannon-Plas",
			"Bunker2-Cannon-Inc",
		],
		[
			"Bunker3-Railgun-Shotgun",
			"Bunker2-Cannon-Shotgun",
		],
		[
			"Bunker3-Railgun-Sniper",
			"Bunker2-Cannon-Sniper",
		],
		[
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVLgt",
			"Tower-Cannon-Lgt",
		],
		[
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVLgt",
			"Tower-Cannon-Lgt",
		],
		[
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVLgt",
			"Tower-Cannon-Lgt",
		],
		[
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVLgt",
			"Tower-Cannon-Lgt",
		],
		[
			"Tower3-Railgun-Med",
			"Tower-VulcanCan",
			"Tower-Cannon-Med",
		],
		[
			"Tower3-Railgun-Med",
			"Tower-VulcanCan",
			"Tower-Cannon-Med",
		],
		[
			"Tower3-Railgun-Shotgun",
			"Tower2-Cannon-Shotgun",
		],
		[
			"Tower3-Railgun-Shotgun",
			"Tower2-Cannon-Shotgun",
		],
		[
			"Bunker4-Mortar-GaussHvyPlas",
			"Bunker3-MortarHvyPlas",
			"Bunker4-Mortar-GaussHvy",
			"Bunker-MortarHvy",
		],
		[
			"Bunker4-MortarGattlingGauss",
			"Bunker3-MortarGattling",
			"Bunker4-Mortar-GaussRot",
			"Bunker-MortarRot",
		],
		[
			"Bunker4-Mortar-GaussRotPlas",
			"Bunker3-MortarRotPlas",
		],
		[
			"Bunker4-Mortar-GaussRamjetHvy",
			"Bunker3-Mortar-RamjetHvy",
		],
		[
			"Bunker4-Mortar-GaussRamjetRot",
			"Bunker3-Mortar-RamjetRot",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		];

		this.artillery = [
		[
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl3-TBM-Earthquake",
		],
		[
			"Empl3-TBM-Precision",
		],
		[
			"Bunker3-Rocket-Archangel",
			"Bunker2-Rocket-Ripple",
		],
		[
			"Emplacement-HvART-pit",
			"Emplacement-Rocket06-IDF",
		],
		];

		this.apArtillery = [
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
			"Emplacement-Rocket06-IDF",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
			"Empl4-HowitzerGauss",
			"Emplacement-Howitzer105",
		],
		[
			"Bunker4-HowitzerGattlingGauss",
			"Bunker3-HowitzerGattling",
			"Bunker4-HowitzerGaussRotPlas",
			"Bunker3-HowitzerRotPlas",
			"Bunker4-HowitzerGaussRot",
			"Bunker2-HowitzerRot",
		],
		[
			"Bunker4-HowitzerGaussRotPlas",
			"Bunker3-HowitzerRotPlas",
			"Bunker4-HowitzerGattlingGauss",
			"Bunker3-HowitzerGattling",
			"Bunker4-HowitzerGaussRot",
			"Bunker2-HowitzerRot",
		],
		[
			"Super-HowitzerGaussPlas-Empl",
			"Super-HowitzerPlas-Empl",
			"Super-HowitzerGauss-Empl",
			"Super-Howitzer-Empl",
		],
		];

		this.atArtillery = [
		[
			"Empl3-TBM-Precision",
		],
		[
			"Empl3-TBM-Precision",
		],
		[
			"Empl3-TBM-Plasmite",
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl3-TBM-Plasmite",
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl4-HowitzerGaussRamjet",
			"Empl3-HowitzerRamjet",
		],
		[
			"Empl4-HowitzerGaussRamjet",
			"Empl3-HowitzerRamjet",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
		],
		[
			"Empl4-HowitzerGaussInc",
			"Emplacement-Howitzer-Incenediary",
		],
		[
			"Bunker4-HowitzerGaussRamjetHvy",
			"Bunker3-HowitzerRamjetHvy",
			"Bunker4-HowitzerGaussHvy",
			"Bunker2-HowitzerHvy",
		],
		[
			"Bunker4-HowitzerGaussHvyPlas",
			"Bunker3-HowitzerHvyPlas",
			"Bunker4-HowitzerGaussHvy",
			"Bunker2-HowitzerHvy",
		],
		[
			"Bunker4-HowitzerGaussRamjetRot",
			"Bunker3-HowitzerRamjetRot",
		],
		[
			"Super-HowitzerGaussRamjet-Empl",
			"Super-HowitzerRamjet-Empl",
			"Super-HowitzerGauss-Empl",
			"Super-Howitzer-Empl",
		],
		[
			"Super-HowitzerGaussPlas-Empl",
			"Super-HowitzerPlas-Empl",
		],
		];

		this.abArtillery = [
		[
			"Empl3-TBM-Precision",
		],
		[
			"Empl3-TBM-Earthquake",
		],
		[
			"Bunker4-HowitzerGaussBB",
			"Bunker3-HowitzerBB",
		],
		];


		this.antiair = [
		[
			"Bunker3-Railgun-Flak",
			"Bunker-Cannon-Flak",
			"Empl3-Railgun-Flak",
			"AASite-QuadBof",
			"Bunker-Rocket-Pod",
			"GuardTower6",
		],
		[
			"Empl3-Railgun-Flak",
			"AASite-QuadBof",
			"Bunker3-Railgun-Flak",
			"Bunker-Cannon-Flak",
			"GuardTower6",
			"Bunker-Rocket-Pod",
		],
		];

		this.hardpoints = [
		[
			"WallTower4-Railgun-GattlingAT",
			"WallTower3-Cannon-HPVGattling",
			"WallTower2-Cannon-Gattling",
			"WallTower3-Railgun-TwinAslt",
			"WallTower2-Cannon-HPVTwinAslt",
			"WallTower-Cannon-TwinAslt",
			"WallTower3-Railgun-Aslt",
			"WallTower2-Cannon-HPVAslt",
			"Wall-VulcanCan",
		],
		[
			"WallTower3-Cannon-Ramjet",
			"WallTower-Rail3",
			"WallTower2-Cannon-HPVHvy",
			"WallTower04",
			"WallTower-Rail2",
			"WallTower-HPVcannon",
			"WallTower03",
		],
		[
			"WallTower3-Railgun-Shotgun",
			"WallTower2-Cannon-Shotgun",
		],
		[
			"WallTower4-Flamer-PlasmaCannon",
			"WallTower3-Cannon-Plas",
			"WallTower2-Cannon-Inc",
		],
		[
			"Tower3-Railgun-Shotgun",
			"Tower2-Cannon-Shotgun",
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVLgt",
			"Tower-Cannon-Lgt",
		],
		[
			"Tower3-Railgun-Shotgun",
			"Tower2-Cannon-Shotgun",
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVLgt",
			"Tower-Cannon-Lgt",
		],
		[
			"Tower3-Railgun-Shotgun",
			"Tower2-Cannon-Shotgun",
			"GuardTower-Rail1",
			"Tower2-Cannon-HPVLgt",
			"Tower-Cannon-Lgt",
		],
		[
			"Tower3-Railgun-Med",
			"Tower-VulcanCan",
			"Tower-Cannon-Med",
		],
		[
			"Tower3-Railgun-Med",
			"Tower-VulcanCan",
			"Tower-Cannon-Med",
		],
		[
			"Tower3-Railgun-Med",
			"Tower-VulcanCan",
			"Tower-Cannon-Med",
		],
		[
			"Bunker4-Mortar-GaussHvyPlas",
			"Bunker3-MortarHvyPlas",
			"Bunker4-Mortar-GaussHvy",
			"Bunker-MortarHvy",
		],
		[
			"Bunker4-MortarGattlingGauss",
			"Bunker3-MortarGattling",
			"Bunker4-Mortar-GaussRot",
			"Bunker-MortarRot",
		],
		[
			"Bunker4-Mortar-GaussHvyPlas",
			"Bunker3-MortarHvyPlas",
		],
		[
			"Bunker4-Mortar-GaussRotPlas",
			"Bunker3-MortarRotPlas",
		],
		[
			"Bunker4-Mortar-GaussRamjetHvy",
			"Bunker3-Mortar-RamjetHvy",
		],
		[
			"Bunker4-Mortar-GaussRamjetRot",
			"Bunker3-Mortar-RamjetRot",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussInc",
			"Emplacement-MortarPit-Incenediary",
			"Empl4-Mortar-Gauss",
			"Emplacement-MortarPit01",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Empl4-Mortar-GaussRamjet",
			"Empl3-Mortar-Ramjet",
		],
		[
			"Emplacement-MortarEMP",
			"Tower2-EMP-Cannon",
		],
		[
			"Super-Railgun-Fort",
			"Super-RotCannon-Fort",
		],
		[
			"X-Super-MassDriver",
			"X-Super-Cannon",
		],
		[
			"Super-FlamerPlasma-Fort",
			"Super-PlasCannon-Fort",
		],
		[
			"Super-MortarGaussPlas-Empl",
			"Super-MortarPlas-Empl",
			"Super-MortarGauss-Empl",
			"Super-Mortar-Empl",
		],
		[
			"Super-MortarGaussRamjet-Empl",
			"Super-MortarRamjet-Empl",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon-Damage01",
			"R-Vehicle-Prop-Halftracks",
			"R-Struc-PowerModuleMk1",
			"R-Defense-Tower-MG1",
			"R-Struc-Factory-Cyborg",
			"R-Wpn-Mortar01Lt",
			"R-Vehicle-Prop-Tracks",
			"R-Wpn-Cannon-TankDestLgt",
			"R-Wpn-Railgun-ProtoTankDest",
			"R-Sys-Sensor-Tower02",
			"R-Wpn-Rocket06-IDF",
			"R-Defense-Empl2-Rocket-Ripple",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl2-MortarEMP",			//EMP Mortars can be really annoying to deal with.
		];

		this.researchPathFundamental = [
			"R-Vehicle-Prop-Halftracks",
			"R-Struc-RepairFacility",
			"R-Struc-PowerModuleMk1",
			"R-Struc-Factory-Cyborg",
			"R-Struc-WindFarm",
			"R-Vehicle-Prop-Tracks",
			"R-Struc-Power-Upgrade03",
			"R-Vehicle-Engine01",
			"R-Vehicle-Body04",
			"R-Struc-Factory-Module",
			"R-Vehicle-Body05",
			"R-Vehicle-Body11",
			"R-Sys-Spade1Hvy",
			"R-Sys-Sensor-Tower02",
			"R-Vehicle-Body23",
			"R-Struc-VTOLFactory",
			"R-Struc-VTOLPad",
			"R-Sys-RadarDetectorTower2",
			"R-Sys-CBSensor-Tower02",
			"R-Struc-Power-Upgrade06",
			"R-Wpn-MortarEMP",
			"R-Vehicle-Armor-Kinetic03",
			"R-Vehicle-Armor-Heat03",
			"R-Sys-Autorepair-General",
			"R-Vehicle-Body02",
			"R-Vehicle-Engine03",
			"R-Vehicle-Body09",
			"R-Sys-Spade2Hvy",
			"R-Defense-Empl2-MortarEMP",
			"R-Struc-RepairFacility2",
			"R-Sys-Resistance-Upgrade01",
			"R-Vehicle-Body25",
			"R-Struc-Power-Upgrade09",
			"R-Vehicle-Armor-Kinetic06",
			"R-Vehicle-Armor-Heat06",
			"R-Sys-Autorepair-Upgrade01",
			"R-Vehicle-Body20",
			"R-Vehicle-Engine04",
			"R-Vehicle-Body22",
			"R-Sys-Spade3Hvy",
			"R-Struc-RepairFacility3",
			"R-Sys-Resistance-Upgrade02",
			"R-Vehicle-Body27",
			"R-Wpn-LasSat",
			"R-Sys-Sensor-WSTower",
			"R-Sys-Sensor-UpLink",
			"R-Vehicle-Armor-Kinetic09",
			"R-Vehicle-Armor-Heat09",
			"R-Sys-Autorepair-Upgrade02",
			"R-Vehicle-Body15",
			"R-Vehicle-Engine06",
			"R-Vehicle-Body13",
			"R-Sys-Spade4Hvy",
			"R-Struc-RepairFacility4",
			"R-Sys-Resistance-Upgrade03",
		];
		
		this.researchPathAT = [
			"R-Wpn-Cannon-TankDestLgt",			//We should buff up our offensive capabilities before researching any defenses.
			"R-Defense-Tower-MG1",				//It'll be more effective to research new structure bodies one at a time,
			"R-Defense-Tower-Cannon-Lgt",			//starting with cheaper towers and emplacements,
			"R-Defense-Tower-Cannon-Med",			//then working up to more expensive bunkers and hardpoints.
			"R-Defense-Bunker-Cannon-Lgt",
			"R-Defense-Bunker-Cannon-Med",
			"R-Defense-Bunker-Cannon-Hvy",
			"R-Defense-WallTower-Cannon-Lgt",
			"R-Defense-WallTower-Cannon-Med",
			"R-Defense-WallTower-Cannon-Hvy",
			"R-Defense-Empl-Mortar",			//Start doing a little artillery research, though cannon research takes priority.
			"R-Defense-Empl-MortarInc",			//Flamers require very little effort to research,
			"R-Wpn-Cannon-IncTankDest",			//so we can afford to play with a few incendiary weapons.
			"R-Sys-Sensor-Tower02",
			"R-Defense-Empl2-Rocket-Ripple",		//Start researching some long-range artillery, even if it won't be researching any upgrades for it.
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Wpn-Cannon-HPVTankDestLgt",		//T2 anti-tank cannon research starts here.
			"R-Defense-Empl2-MortarEMP",			//EMP Mortars can be really annoying to deal with.
			"R-Defense-Bunker-Cannon-Aslt",
			"R-Defense-WallTower-Cannon-Aslt",
			"R-Defense-Bunker-Cannon-TwinAslt",
			"R-Defense-WallTower-Cannon-TwinAslt",
			"R-Defense-Tower2-Cannon-HPVLgt",
			"R-Defense-Tower2-Cannon-HPVMed",
			"R-Defense-Bunker2-Rocket-Ripple",		//Again, we're trying to research new structure bodies one at a time.
			"R-Defense-Bunker2-Cannon-Inc",
			"R-Defense-Bunker2-Cannon-HPVHvy",
			"R-Defense-Bunker-MortarHvy",			//Don't fall behind in artillery research.
			"R-Defense-WallTower2-Cannon-Inc",
			"R-Defense-WallTower2-Cannon-HPVHvy",
			"R-Defense-Empl3-TBM-FuelAir",		//Start replacing Ripple Rockets with far more deadly TBMs (although keep using Ripple Rockets as anti-personnel artillery for now).
			"R-Wpn-Railgun-TankDestLgt",			//T3 anti-tank cannon/railgun research starts here.
			"R-Defense-Bunker2-Cannon-HPVTwinAslt",
			"R-Defense-WallTower2-Cannon-HPVTwinAslt",
			"R-Defense-Tower3-Railgun-Lgt",
			"R-Defense-Tower3-Railgun-Med",
			"R-Defense-Empl3-TBM-Precision",		//Should take out heavy tanks from afar with ease.
			"R-Defense-Bunker3-Railgun-Hvy",
			"R-Defense-WallTower3-Railgun-Hvy",
			"R-Wpn-Missile-ROF03",				//Finish up TBM research.
			"R-Wpn-Missile-Damage03",
			"R-Defense-Empl2-Howitzer",			//Start focusing on researching artillery-line weapons to finally phase out those Ripple Rockets.
			"R-Defense-Bunker2-HowitzerHvy",		//Nice complement to TBMs.
			"R-Defense-Bunker3-Railgun-TwinAslt",
			"R-Defense-WallTower3-Railgun-TwinAslt",
			"R-Wpn-Rail-Damage06",
			"R-Wpn-Rail-ROF06",
			"R-Wpn-Rail-Accuracy06",			//Important anti-tank direct-fire research ends here.
			"R-Defense-Empl4-Mortar-Gauss",		//Start finishing up important anti-tank artillery research.
			"R-Defense-Empl4-Mortar-GaussInc",
			"R-Defense-Empl4-HowitzerGauss",
			"R-Defense-Bunker4-Mortar-GaussHvy",
			"R-Defense-Bunker4-HowitzerGaussHvy",
			"R-Wpn-Artillery-Accuracy09",
			"R-Wpn-Artillery-Damage09",
			"R-Wpn-Artillery-ROF09",			//Important anti-tank artillery research ends here.
			"R-Defense-Bunker-MortarRot",			//Start research on fortresses and firebases,
			"R-Defense-Bunker2-HowitzerRot",		//acquiring new anti-personnel defenses along the way.
			"R-Defense-Super-Mortar",
			"R-Defense-Super-Howitzer",
			"R-Defense-Super-RotCannon",
			"R-Defense-Super-Cannon",
			"R-Defense-Bunker4-Mortar-GaussRot",
			"R-Defense-Bunker4-HowitzerGaussRot",
			"R-Defense-Super-MortarGauss",
			"R-Defense-Super-HowitzerGauss",
			"R-Defense-Super-RotRailgun",
			"R-Defense-MassDriver",
		];
		
		this.researchPathAP = [
			"R-Wpn-Cannon1Mk1",
			"R-Defense-Tower-MG1",
			"R-Defense-Tower-Cannon-Lgt",
			"R-Defense-Bunker-Cannon-Lgt",
			"R-Defense-Bunker-Cannon-Aslt",		//Assault Cannons will serve as our anti-personnel weapons of choice
			"R-Defense-Bunker-Cannon-TwinAslt",		//until the Blunderbuss is researched.
			"R-Defense-WallTower-Cannon-Lgt",
			"R-Defense-WallTower-Cannon-Aslt",
			"R-Defense-WallTower-Cannon-TwinAslt",
			"R-Defense-Empl-Mortar",			//Mortars can be useful anti-personnel weapons early on, even if we're currently focusing on researching cannons.
			"R-Defense-Tower2-Cannon-Shotgun",		//Once Blunderbuss is researched,
			"R-Defense-Bunker2-Cannon-Shotgun",		//there's no longer much of a need for Assault Cannons.
			"R-Defense-Bunker2-Cannon-Sniper",
			"R-Sys-Sensor-Tower02",
			"R-Defense-Bunker2-Rocket-Ripple",		//Ripple Rockets, although of the rockets line,
			"R-Defense-Empl2-Rocket-Ripple",		//make for decent long-range anti-personnel artillery at this point.
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Bunker-MortarInc",			//Flamers are surprisingly inexpensive to research,
			"R-Wpn-Cannon-IncTankDest",			//so we can afford to play with a few incendiary weapons.
			"R-Defense-Bunker2-Cannon-Inc",
			"R-Defense-WallTower2-Cannon-Shotgun",
			"R-Defense-WallTower2-Cannon-Inc",
			"R-Defense-Empl2-Howitzer",			//Start replacing Ripple Rockets with Howitzers.
			"R-Defense-Bunker-MortarRot",			//Don't fall behind on artillery research.
			"R-Defense-Bunker2-Cannon-HPVTwinAslt",
			"R-Defense-WallTower2-Cannon-HPVTwinAslt",
			"R-Defense-Tower3-Railgun-Lgt",		//T3 research starts here.
			"R-Defense-Tower3-Railgun-Shotgun",
			"R-Defense-Bunker3-Railgun-Shotgun",
			"R-Defense-Bunker3-Railgun-Sniper",
			"R-Defense-WallTower3-Railgun-Shotgun",
			"R-Defense-Bunker2-HowitzerRot",
			"R-Defense-Bunker3-Railgun-TwinAslt",
			"R-Defense-WallTower3-Railgun-TwinAslt",
			"R-Wpn-Rail-ROF06",
			"R-Wpn-Rail-Damage06",
			"R-Wpn-Rail-Accuracy06",
			"R-Defense-Empl4-Mortar-Gauss",		//Now that important cannon/railgun research is finished,
			"R-Defense-Empl4-HowitzerGauss",		//let's turn our focus to finishing artillery research.
			"R-Defense-Empl4-Mortar-GaussInc",
			"R-Defense-Bunker4-Mortar-GaussRot",
			"R-Defense-Bunker4-HowitzerGaussRot",
			"R-Wpn-Artillery-ROF09",
			"R-Wpn-Artillery-Accuracy09",
			"R-Wpn-Artillery-Damage09",			//Important anti-personnel artillery research ends here.
			"R-Defense-Bunker-MortarHvy",			//Start research on fortresses and firebases,
			"R-Defense-Bunker2-HowitzerHvy",		//acquiring new anti-tank defenses along the way.
			"R-Defense-Super-Mortar",
			"R-Defense-Super-Howitzer",
			"R-Defense-Super-RotCannon",
			"R-Defense-Super-Cannon",
			"R-Defense-Bunker4-Mortar-GaussHvy",
			"R-Defense-Bunker4-HowitzerGaussHvy",
			"R-Defense-Super-MortarGauss",
			"R-Defense-Super-HowitzerGauss",
			"R-Defense-Super-RotRailgun",
			"R-Defense-MassDriver",
		];
		
		this.researchPathAA = [
			"R-Wpn-Rocket05-MiniPod",			//This is in case Scavenger Choppers show up.
			"R-Defense-Tower-MG1",				//Some of these listed defenses, while not helpful at anti-air work,
			"R-Defense-Tower-Cannon-Lgt",			//are useful for other roles, and just so happen to lie close to the anti-air path.
			"R-Defense-Tower-Rocket-Pod",
			"R-Defense-Bunker-Cannon-Lgt",
			"R-Defense-Bunker-Rocket-Pod",
			"R-Defense-Bunker-Cannon-Flak",
			"R-Defense-Bunker3-Railgun-Flak",
			"R-Wpn-Rail-ROF06",
			"R-Wpn-Rail-Damage06",
			"R-Wpn-Rail-Accuracy06",
		];
		
		this.researchPathAB = [
			"R-Wpn-Railgun-ProtoTankDest",
			"R-Defense-Empl2-Rocket-Ripple",		//Ripple Rockets are a prerequisite towards researching TBMs.
			"R-Sys-Sensor-Tower02",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl3-TBM-FuelAir",
			"R-Defense-Empl3-TBM-Precision",
			"R-Wpn-LasSat",
			"R-Defense-Empl3-TBM-Earthquake",
			"R-Wpn-Missile-ROF03",
			"R-Defense-Empl-Mortar",			//Just happened to lie close to the path towards researching
			"R-Defense-Empl2-Howitzer",			//the Ground Shaker and Meteor Launcher anti-structure Howitzers.
			"R-Defense-Bunker2-HowitzerHvy",
			"R-Defense-Bunker3-HowitzerBB",
			"R-Defense-Empl4-Mortar-Gauss",
			"R-Defense-Empl4-HowitzerGauss",
			"R-Defense-Bunker4-HowitzerGaussHvy",
			"R-Defense-Bunker4-HowitzerGaussBB",
			"R-Wpn-Artillery-ROF09",
			"R-Wpn-Artillery-Accuracy09",
			"R-Wpn-Rail-Damage06",				//Save upgrading the Proto-Railgun for last.
			"R-Wpn-Rail-Accuracy06",
			"R-Wpn-Rail-ROF06",
		];
	
		//Although the AI will eventually pursue these research items when it has run out of things to pursue,
		//it will also pursue them the moment they become available for direct research.
		this.researchPathExotic = [
			"R-Wpn-HowitzerGaussRamjet",
			"R-Defense-Empl4-HowitzerGaussRamjet",
			"R-Wpn-HowitzerGaussRamjetHvy",
			"R-Defense-Bunker4-HowitzerGaussRamjetHvy",
			"R-Wpn-HowitzerGaussRamjetRot",
			"R-Defense-Bunker4-HowitzerGaussRamjetRot",
			"R-Defense-Super-HowitzerRamjet",
			"R-Defense-Super-HowitzerGaussRamjet",
			"R-Wpn-HowitzerGattlingGauss",
			"R-Defense-Bunker4-HowitzerGattlingGauss",
			"R-Wpn-TBM-Plasmite",
			"R-Defense-Empl3-TBM-Plasmite",
			"R-Wpn-HowitzerGaussInc",
			"R-Defense-Empl4-HowitzerGaussInc",
			"R-Wpn-HowitzerGaussHvyPlas",
			"R-Defense-Bunker4-HowitzerGaussHvyPlas",
			"R-Wpn-HowitzerGaussRotPlas",
			"R-Defense-Bunker4-HowitzerGaussRotPlas",
			"R-Defense-Super-HowitzerPlas",
			"R-Defense-Super-HowitzerGaussPlas",
			"R-Wpn-HowitzerRamjet",
			"R-Defense-Empl3-HowitzerRamjet",
			"R-Wpn-HowitzerRamjetHvy",
			"R-Defense-Bunker3-HowitzerRamjetHvy",
			"R-Wpn-HowitzerRamjetRot",
			"R-Defense-Bunker3-HowitzerRamjetRot",
			"R-Wpn-HowitzerGattling",
			"R-Defense-Bunker3-HowitzerGattling",
			"R-Wpn-Howitzer-Incenediary",
			"R-Defense-Empl2-HowitzerInc",
			"R-Wpn-HowitzerHvyPlas",
			"R-Defense-Bunker3-HowitzerHvyPlas",
			"R-Wpn-HowitzerRotPlas",
			"R-Defense-Bunker3-HowitzerRotPlas",
			"R-Wpn-Mortar-GaussRamjet",
			"R-Defense-Empl4-Mortar-GaussRamjet",
			"R-Wpn-Mortar-GaussRamjetHvy",
			"R-Defense-Bunker4-Mortar-GaussRamjetHvy",
			"R-Wpn-Mortar-GaussRamjetRot",
			"R-Defense-Bunker4-Mortar-GaussRamjetHvy",
			"R-Defense-Super-MortarRamjet",
			"R-Defense-Super-MortarGaussRamjet",
			"R-Wpn-MortarGattlingGauss",
			"R-Defense-Bunker4-MortarGattlingGauss",
			"R-Wpn-Mortar-GaussInc",
			"R-Defense-Empl4-Mortar-GaussInc",
			"R-Wpn-Mortar-GaussHvyPlas",
			"R-Defense-Bunker4-Mortar-GaussHvyPlas",
			"R-Wpn-Mortar-GaussRotPlas",
			"R-Defense-Bunker4-Mortar-GaussRotPlas",
			"R-Defense-Super-MortarPlas",
			"R-Defense-Super-MortarGaussPlas",
			"R-Wpn-Mortar-Ramjet",
			"R-Defense-Empl3-Mortar-Ramjet",
			"R-Wpn-Mortar-RamjetHvy",
			"R-Defense-Bunker3-Mortar-RamjetHvy",
			"R-Wpn-Mortar-RamjetRot",
			"R-Defense-Bunker3-Mortar-RamjetRot",
			"R-Wpn-MortarGattling",
			"R-Defense-Bunker3-MortarGattling",
			"R-Wpn-Mortar-Incenediary",
			"R-Defense-Empl-MortarInc",
			"R-Wpn-MortarHvyPlas",
			"R-Defense-Bunker3-MortarHvyPlas",
			"R-Wpn-MortarRotPlas",
			"R-Defense-Bunker3-MortarRotPlas",
			"R-Wpn-Cannon-Ramjet",
			"R-Wpn-Cannon-Ramjet-TankDest",
			"R-Defense-Bunker3-Cannon-Ramjet",
			"R-Defense-WallTower3-Cannon-Ramjet",
			"R-Wpn-Flamer-PlasmaCannon",
			"R-Wpn-Flamer-PlasCan-TankDest",
			"R-Defense-Bunker4-Flamer-PlasmaCannon",
			"R-Defense-WallTower4-Flamer-PlasmaCannon",
			"R-Defense-Super-PlasCannon",
			"R-Defense-Super-FlamerPlasma",
			"R-Wpn-Railgun-GattlingAT",
			"R-Defense-Bunker4-Railgun-GattlingAT",
			"R-Defense-WallTower4-Railgun-GattlingAT",
			"R-Wpn-Cannon-Plas",
			"R-Wpn-Cannon-PlasTankDest",
			"R-Defense-Bunker3-Cannon-Plas",
			"R-Defense-WallTower3-Cannon-Plas",
			"R-Wpn-Cannon-HPVGattling",
			"R-Defense-Bunker3-Cannon-HPVGattling",
			"R-Defense-WallTower3-Cannon-HPVGattling",
			"R-Wpn-Cannon-Inc",
			"R-Wpn-Cannon-IncTankDest",
			"R-Defense-Bunker2-Cannon-Inc",
			"R-Defense-WallTower2-Cannon-Inc",
			"R-Wpn-Cannon-Gattling",
			"R-Defense-Bunker2-Cannon-Gattling",
			"R-Defense-WallTower2-Cannon-Gattling",
		];

	break;
	case 3: //Rocket Personality

		this.tankBodies = [contingencyBodiesSuperArmored,];
		this.tankBodies[0] = this.tankBodies[0].concat(contingencyBodiesHeavyArmored,contingencyBodiesMediumArmored,contingencyBodiesLightArmored);
	
		this.tankBodiesLight = [contingencyBodiesLightArmored,];
		this.tankBodiesMedium = [contingencyBodiesMediumArmored,];
		this.tankBodiesHeavy = [contingencyBodiesHeavyArmored,];
		this.tankBodiesSuper = [contingencyBodiesSuperArmored,];
		
		sensorBodies = contingencyBodiesHeavyArmored;
		empBodies = contingencyBodiesMediumArmored;

		this.tankPropulsions = [
		[
			"tracked01", // tracks
			"HalfTrack", // half-track
			"wheeled01", // wheels
		],
		];

		sensorPropulsions = this.tankPropulsions[0];
		empPropulsions = this.tankPropulsions[0];

		RATE_AP_LIGHT = 1;	//Not many good anti-personnel weapons to choose from for light tanks to mount.
		RATE_AP_MEDIUM = 24;	//Mini-Rocket Arrays have good initiative compared to Mini-Rocket Pods.
		RATE_AP_HEAVY = 4;	//We need our rapid-firing Quad Minipod tanks to be durable enough for it to count,
		RATE_AP_SUPER = 4;	//so we'll be building larger, heavily-armored anti-personnel vehicles more frequently.
		RATE_AP_SUPER_A = 4;	//Rocketstorms make for effective anti-personnel weapons for super tanks,
		RATE_AP_SUPER_B = 1;	//so build them more frequently if possible.
		
		this.apWeapons = [
		[
			"Missile-MdArtHvy",
			"Rocket-TopAttackHvy",
			"Rocket-MRLHvy",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Missile-MdArtHvy",
			"Rocket-TopAttackHvy",
			"Rocket-MRLHvy",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Rocket-Gattling",
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];

		this.apWeaponsLight = [
		[
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];

		this.apWeaponsMedium = [
		[
			"Rocket-TopAtkPlas",
			"Rocket-TopAtkInc",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Rocket-TopAtkPlas",
			"Rocket-TopAtkInc",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];

		this.apWeaponsHeavy = [
		[
			"Rocket-TopAtkPlasHvy",
			"Rocket-TopAtkIncHvy",
			"Missile-MdArtHvy",
			"Rocket-TopAttackHvy",
			"Rocket-MRLHvy",
			"Rocket-TopAtkPlas",
			"Rocket-TopAtkInc",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Missile-MdArtHvy",
			"Rocket-TopAttackHvy",
			"Rocket-MRLHvy",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
		],
		[
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		[
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];

		this.apWeaponsSuper = [
		[
			"Rocket-Gattling",
		],
		];

		RATE_AT_LIGHT = 1;	//Not many good anti-tank weapons to choose from for light tanks to mount.
		RATE_AT_MEDIUM = 20;	//Lancers are probably the best anti-tank weapons to use.
		RATE_AT_HEAVY = 8;	//Heavy Lancers aren't as cost-effective as lighter Lancers.
		RATE_AT_SUPER = 2;
		RATE_AT_SUPER_A = 1;	//Rocketstorms aren't very effective as anti-tank weapons.
		RATE_AT_SUPER_B = 4;
		
		this.atWeapons = [
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Rocket-Gattling",
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
		],
		];

		this.atWeaponsLight = [
		[
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
		],
		];

		this.atWeaponsMedium = [
		[
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Rocket-TopAtkPlas",
			"Rocket-TopAtkInc",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Rocket-TopAtkPlas",
			"Rocket-TopAtkInc",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
		],
		];

		this.atWeaponsHeavy = [
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Rocket-TopAtkPlasHvy",
			"Rocket-TopAtkIncHvy",
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Rocket-TopAtkPlasHvy",
			"Rocket-TopAtkIncHvy",
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-TopAtkPlas",
			"Rocket-TopAtkInc",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
		],
		];

		this.atWeaponsSuper = [
		[
			"Rocket-Gattling",
		],
		[
			"Cannon-Ramjet",
		],
		[
			"Cannon-Ramjet",
		],
		[
			"Cannon-Ramjet",
		],
		];

		RATE_AB_LIGHT = 0;	//No good anti-structure weapons are available for light tanks.
		RATE_AB_MEDIUM = 16;	//Bunker Busters are probably the best anti-structure weapons to use.
		RATE_AB_HEAVY = 2;	//Heavy Lancers aren't anywhere near as cost-effective as Bunker Busters.
		RATE_AB_SUPER = 1;
		RATE_AB_SUPER_A = 0;	//No effective weapons to choose from for ultra-heavy tanks,
		RATE_AB_SUPER_B = 1;	//so they'll most likely mount 2 Heavy Lancer turrets instead.
		
		this.abWeapons = [
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Rocket-BB2",
			"Rocket-BB",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		];

		this.abWeaponsLight = [
		[
		],
		];

		this.abWeaponsMedium = [
		[
			"Rocket-BB2",
			"Rocket-BB",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		];

		this.abWeaponsHeavy = [
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Rocket-BB2",
			"Rocket-BB",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Rocket-BB2",
			"Rocket-BB",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Missile-A-THvy",
			"Rocket-HvyA-THvy",
			"Rocket-LtA-THvy",
			"Rocket-BB2",
			"Rocket-BB",
			"Missile-A-T",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
		],
		[
			"Cannon-Ramjet-TankDest",
		],
		];

		this.abWeaponsSuper = [
		[
			"Cannon-Ramjet",
		],
		];

		RATE_AA_LIGHT = 1;	//Mini-Rocket Pods are better than nothing.
		RATE_AA_MEDIUM = 16;	//Sunbursts are probably more valuable due to their higher damage-per-salvo.
		RATE_AA_HEAVY = 2;	//Although, the longer-ranged SAMs have their own special place as anti-air weapons.
		RATE_AA_SUPER = 1;
		RATE_AA_SUPER_A = 1;	//Rocketstorms could work as effective anti-air weapons,
		RATE_AA_SUPER_B = 2;	//though Sunbursts and SAMs are more preferable as cost-effective alternates.
		
		this.aaWeapons = [
		[
			"Missile-HvySAM2",
			"Missile-HvySAM",
			"Missile-LtSAM2",
			"Missile-LtSAM",
			"Rocket-Cherub",
			"Rocket-Sunburst",
		],
		[
			"Rocket-Gattling",
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-Cherub",
			"Rocket-Sunburst",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
		],
		];

		this.aaWeaponsLight = [
		[
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
		],
		];

		this.aaWeaponsMedium = [
		[
			"Missile-LtSAM2",
			"Missile-LtSAM",
		],
		[
			"Rocket-Cherub",
			"Rocket-Sunburst",
		],
		[
			"Rocket-Cherub",
			"Rocket-Sunburst",
		],
		[
			"Rocket-Cherub",
			"Rocket-Sunburst",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
		],
		];

		this.aaWeaponsHeavy = [
		[
			"Missile-HvySAM2",
			"Missile-HvySAM",
			"Missile-LtSAM2",
			"Missile-LtSAM",
			"Rocket-Pod3Quad",
			"Rocket-Pod2Quad",
			"Rocket-PodQuad",
			"Rocket-Pod3Twin",
			"Rocket-Pod2Twin",
			"Rocket-PodTwin",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
		],
		];

		this.aaWeaponsSuper = [
		[
			"Rocket-Gattling",
		],
		];

		this.harassWeapons = [
		[
			"SpyTurretNEXUS",
			"SpyTurret03",
			"SpyTurret02",
			"SpyTurret01",
			"Missile-MdArt",
			"Rocket-TopAttack",
			"Rocket-MRL",
			"Rocket-BB2",
			"Rocket-BB",
			"Rocket-HvyA-T",
			"Rocket-LtA-T",
			"Rocket-Pod3",
			"Rocket-Pod2",
			"Rocket-Pod",
			"Cannon1Mk1",
			"MG1Mk1",
		],
		];
	
		this.apCyborgStats = [
		[
			["HvyCyb-Bod-Missile-MdArt","HvyCyb-Wpn-Missile-MdArt","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-TopAttack","HvyCyb-Wpn-Rocket-TopAttack","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-Rocket-Pod3","HvyCyb-Wpn-Rocket-Pod3","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod2","HvyCyb-Wpn-Rocket-Pod2","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod","HvyCyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		[
			["HvyCyb-Bod-Rocket-TopAtkPlas","HvyCyb-Wpn-Rocket-TopAtkPlas","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-TopAtkInc","HvyCyb-Wpn-Rocket-TopAtkInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Missile-MdArt","HvyCyb-Wpn-Missile-MdArt","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-TopAttack","HvyCyb-Wpn-Rocket-TopAttack","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-MRL","HvyCyb-Wpn-Rocket-MRL","HvyCyborgLegs"],
		],
		];

		this.atCyborgStats = [
		[
			["Cyb-Hvybod-A-T","Cyb-Hvywpn-A-T","HvyCyborgLegs"],
			["Cyb-Hvybod-TK","Cyb-Hvywpn-TK","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-LtA-T","HvyCyb-Wpn-Rocket-LtA-T","HvyCyborgLegs"],
		],
		[
			["HvyCyb-Bod-Rocket-TopAtkPlas","HvyCyb-Wpn-Rocket-TopAtkPlas","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-TopAtkInc","HvyCyb-Wpn-Rocket-TopAtkInc","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod3","HvyCyb-Wpn-Rocket-Pod3","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod2","HvyCyb-Wpn-Rocket-Pod2","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod","HvyCyborgLegs"],
			["CyborgCannonGrd","CyborgCannon","CyborgLegs"],
		],
		[
			["Cyb-Bod-Atmiss","Cyb-Wpn-Atmiss","CyborgLegs"],
			["Cyb-Bod-Rocket-HvyA-T","Cyb-Wpn-Rocket-HvyA-T","CyborgLegs"],
			["CyborgRkt1Ground","CyborgRocket","CyborgLegs"],
		],
		];

		this.abCyborgStats = [
		[
			["Cyb-Hvybod-A-T","Cyb-Hvywpn-A-T","HvyCyborgLegs"],
			["Cyb-Hvybod-TK","Cyb-Hvywpn-TK","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-LtA-T","HvyCyb-Wpn-Rocket-LtA-T","HvyCyborgLegs"],
		],
		];

		this.aaCyborgStats = [
		[
			["HvyCyb-Bod-Missile-HvySAM","HvyCyb-Wpn-Missile-HvySAM","HvyCyborgLegs"],
			["HvyCyb-Bod-Missile-LtSAM","HvyCyb-Wpn-Missile-LtSAM","HvyCyborgLegs"],
		],
		[
			["Cyb-Bod-Rocket-Cherub","Cyb-Wpn-Rocket-Cherub","CyborgLegs"],
			["Cyb-Bod-Rocket-Sunburst","Cyb-Wpn-Rocket-Sunburst","CyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod3","HvyCyb-Wpn-Rocket-Pod3","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod2","HvyCyb-Wpn-Rocket-Pod2","HvyCyborgLegs"],
			["HvyCyb-Bod-Rocket-Pod","HvyCyb-Wpn-Rocket-Pod","HvyCyborgLegs"],
			["CyborgChain1Ground","CyborgChaingun","CyborgLegs"],
		],
		];

		this.vtolBodies = [contingencyBodiesMediumVtol, contingencyBodiesSuperVtol, ];
		this.vtolBodies[0] = this.vtolBodies[0].concat(contingencyBodiesLightVtol);

		this.vtolBodiesLight = [contingencyBodiesLightCheap, ];
		this.vtolBodiesMedium = [contingencyBodiesMediumCheap, ];
		this.vtolBodiesHeavy = [contingencyBodiesHeavyCheap, ];
		this.vtolBodiesSuper = [contingencyBodiesSuperCheap, ];

		this.vtolWeapons = [
		[
			"Missile-VTOL-MdArtHvy",
			"Rocket-VTOL-TopAttackHvy",
			"Rocket-VTOL-MRLHvy",
			"Missile-VTOL-MdArt",
			"Rocket-VTOL-TopAttack",
			"Rocket-VTOL-MRL",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
			"Bomb2-VTOL-HvHE",
			"Bomb1-VTOL-LtHE",
		],
		[
			"Rocket-VTOL-BB2",
			"Rocket-VTOL-BB",
		],
		[
			"Missile-VTOL-ATHvy",
			"Rocket-VTOL-HvyA-THvy",
			"Rocket-VTOL-LtA-THvy",
			"Missile-VTOL-AT",
			"Rocket-VTOL-HvyA-T",
			"Rocket-VTOL-LtA-T",
		],
		];
		
		RATE_VTOL_AP_LIGHT = 32;	//Most VTOL weapons here have an ammo capacity of just 1 shot or salvo,
		RATE_VTOL_AP_MEDIUM = 16;	//so there isn't much of a need for heavy armor.
		RATE_VTOL_AP_HEAVY = 2;
		RATE_VTOL_AP_SUPER = 1;
		RATE_VTOL_AP_SUPER_A = 1;
		RATE_VTOL_AP_SUPER_B = 0;
		
		this.apVtolWeaponsLight = [
		[
			"Missile-VTOL-MdArt",
			"Rocket-VTOL-TopAttack",
			"Rocket-VTOL-MRL",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
			"Bomb2-VTOL-HvHE",
			"Bomb1-VTOL-LtHE",
		],
		[
			"Rocket-VTOL-TopAtkPlas",
			"Rocket-VTOL-TopAtkInc",
		],
		];
		
		this.apVtolWeaponsMedium = [
		[
			"Missile-VTOL-MdArtHvy",
			"Rocket-VTOL-TopAttackHvy",
			"Rocket-VTOL-MRLHvy",
			"Rocket-VTOL-MRL",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
			"Bomb2-VTOL-HvHE",
			"Bomb1-VTOL-LtHE",
		],
		[
			"Rocket-VTOL-TopAtkPlasHvy",
			"Rocket-VTOL-TopAtkIncHvy",
		],
		];
		
		this.apVtolWeaponsHeavy = [
		[
			"Missile-VTOL-MdArt",
			"Rocket-VTOL-TopAttack",
			"Rocket-VTOL-MRL",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
			"Bomb2-VTOL-HvHE",
			"Bomb1-VTOL-LtHE",
		],
		[
			"Rocket-VTOL-TopAtkPlas",
			"Rocket-VTOL-TopAtkInc",
		],
		];
		
		this.apVtolWeaponsSuper = [
		[
			"Missile-VTOL-MdArtHvy",
			"Rocket-VTOL-TopAttackHvy",
			"Rocket-VTOL-MRLHvy",
			"Rocket-VTOL-MRL",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
			"Bomb2-VTOL-HvHE",
			"Bomb1-VTOL-LtHE",
		],
		[
			"Rocket-VTOL-TopAtkPlasHvy",
			"Rocket-VTOL-TopAtkIncHvy",
		],
		];
		

		RATE_VTOL_AT_LIGHT = 32;	//Most VTOL weapons here have an ammo capacity of just 1 shot or salvo,
		RATE_VTOL_AT_MEDIUM = 16;	//so there isn't much of a need for heavy armor.
		RATE_VTOL_AT_HEAVY = 2;
		RATE_VTOL_AT_SUPER = 1;
		RATE_VTOL_AT_SUPER_A = 1;
		RATE_VTOL_AT_SUPER_B = 0;
		
		this.atVtolWeaponsLight = [
		[
			"Missile-VTOL-AT",
			"Rocket-VTOL-HvyA-T",
			"Rocket-VTOL-LtA-T",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
			"Bomb2-VTOL-HvHE",
			"Bomb1-VTOL-LtHE",
		],
		];
		
		this.atVtolWeaponsMedium = [
		[
			"Missile-VTOL-ATHvy",
			"Rocket-VTOL-HvyA-THvy",
			"Rocket-VTOL-LtA-THvy",
			"Rocket-VTOL-LtA-T",
		],
		];
		
		this.atVtolWeaponsHeavy = [
		[
			"Missile-VTOL-AT",
			"Rocket-VTOL-HvyA-T",
			"Rocket-VTOL-LtA-T",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
			"Bomb2-VTOL-HvHE",
			"Bomb1-VTOL-LtHE",
		],
		];
		
		this.atVtolWeaponsSuper = [
		[
			"Missile-VTOL-ATHvy",
			"Rocket-VTOL-HvyA-THvy",
			"Rocket-VTOL-LtA-THvy",
			"Rocket-VTOL-LtA-T",
		],
		];
		

		RATE_VTOL_AB_LIGHT = 32;	//Bunker Busters are the weapon of choice here.
		RATE_VTOL_AB_MEDIUM = 4;
		RATE_VTOL_AB_HEAVY = 2;
		RATE_VTOL_AB_SUPER = 1;
		RATE_VTOL_AB_SUPER_A = 1;
		RATE_VTOL_AB_SUPER_B = 0;
		
		this.abVtolWeaponsLight = [
		[
			"Rocket-VTOL-BB2",
			"Rocket-VTOL-BB",
			"Missile-VTOL-AT",
			"Rocket-VTOL-HvyA-T",
			"Rocket-VTOL-LtA-T",
		],
		];
		
		this.abVtolWeaponsMedium = [
		[
			"Missile-VTOL-ATHvy",
			"Rocket-VTOL-HvyA-THvy",
			"Rocket-VTOL-LtA-THvy",
			"Rocket-VTOL-LtA-T",
		],
		];
		
		this.abVtolWeaponsHeavy = [
		[
			"Rocket-VTOL-BB2",
			"Rocket-VTOL-BB",
			"Missile-VTOL-AT",
			"Rocket-VTOL-HvyA-T",
			"Rocket-VTOL-LtA-T",
		],
		];
		
		this.abVtolWeaponsSuper = [
		[
			"Missile-VTOL-ATHvy",
			"Rocket-VTOL-HvyA-THvy",
			"Rocket-VTOL-LtA-THvy",
			"Rocket-VTOL-LtA-T",
		],
		];
		

		RATE_VTOL_AA_LIGHT = 1;		//Speed isn't necessary for defending VTOLs.
		RATE_VTOL_AA_MEDIUM = 0;
		RATE_VTOL_AA_HEAVY = 0;
		RATE_VTOL_AA_SUPER = 0;
		RATE_VTOL_AA_SUPER_A = 1;
		RATE_VTOL_AA_SUPER_B = 0;
		
		this.aaVtolWeaponsLight = [
		[
			"Rocket-VTOL-Cherub",
			"Rocket-VTOL-Sunburst",
			"Rocket-VTOL-Pod3",
			"Rocket-VTOL-Pod2",
			"Rocket-VTOL-Pod",
		],
		[
			"Missile-HvySAM2-VTOL",
			"Missile-HvySAM-VTOL",
			"Missile-LtSAM2-VTOL",
			"Missile-LtSAM-VTOL",
		],
		];
		
		this.aaVtolWeaponsMedium = [
		];
		
		this.aaVtolWeaponsHeavy = [
		[
		],
		];
		
		this.aaVtolWeaponsSuper = [
		[
		],
		];
		

		this.defenses = [
		[
			"Bunker3-Rocket-TopAtkPlasHvy",
			"Bunker2-Rocket-TopAtkIncHvy",
			"Bunker3-Rocket-SeraphHvy",
			"Bunker2-Rocket-TopAttackHvy",
			"Bunker-Rocket-MRLHvy",
		],
		[
			"Empl3-Rocket-TopAtkPlas",
			"Empl2-Rocket-TopAtkInc",
			"Emplacement-MdART-pit",
			"Empl2-Rocket-TopAttack",
			"Emplacement-MRL-pit",
		],
		[
			"GuardTower-ATMiss",
			"Tower2-Rocket-AT2",
			"GuardTower5",
		],
		[
			"Tower3-Rocket-Pod3",
			"Tower2-Rocket-Pod2",
			"GuardTower6",
			"Tower-Cannon-Lgt",
			"GuardTower1",
		],
		[
			"Bunker3-Rocket-AT3Hvy",
			"Bunker2-Rocket-AT2Hvy",
			"Bunker-Rocket-ATHvy",
			"PillBox6",
			"PillBox4",
		],
		[
			"Bunker4-Rocket-Gattling",
			"Bunker3-Rocket-Pod3Quad",
			"Bunker2-Rocket-Pod2Quad",
			"Bunker-Rocket-PodQuad",
			"Bunker3-Rocket-Pod3Twin",
			"Bunker2-Rocket-Pod2Twin",
			"Bunker-Rocket-PodTwin",
			"Bunker3-Rocket-Pod3",
			"Bunker2-Rocket-Pod2",
			"Bunker-Rocket-Pod",
			"PillBox4",
			"PillBox1",
		],
		];

		this.artillery = [
		[
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl3-TBM-Earthquake",
		],
		[
			"Empl3-TBM-Precision",
		],
		[
			"Bunker3-Rocket-Archangel",
			"Bunker2-Rocket-Ripple",
		],
		[
			"Emplacement-HvART-pit",
			"Emplacement-Rocket06-IDF",
		],
		];

		this.apArtillery = [
		[
			"Bunker3-Rocket-Archangel",
			"Bunker2-Rocket-Ripple",
		],
		[
			"Empl4-Rocket-LasProp-Plas",
			"Empl4-Rocket-LasProp-AP",
			"Emplacement-HvART-pit",
			"Emplacement-Rocket06-IDF",
		],
		];

		this.atArtillery = [
		[
			"Empl3-TBM-Precision",
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl4-Rocket-LasProp-Plas",
			"Empl3-TBM-Plasmite",
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl4-Rocket-LasProp-AT",
			"Empl3-TBM-Precision",
			"Empl3-TBM-FuelAir",
		],
		[
			"Empl3-TBM-Plasmite",
			"Empl4-Rocket-LasProp-Plas",
			"Empl3-TBM-FuelAir",
		],
		[
			"Bunker3-Rocket-Archangel",
			"Bunker2-Rocket-Ripple",
		],
		[
			"Emplacement-HvART-pit",
			"Emplacement-Rocket06-IDF",
		],
		];

		this.abArtillery = [
		[
			"Empl3-TBM-Precision",
		],
		[
			"Empl3-TBM-Earthquake",
		],
		];


		this.antiair = [
		[
			"Empl3-Rocket-Cherub",
			"P0-AASite-Sunburst",
			"Tower3-Rocket-Pod3",
			"Tower2-Rocket-Pod2",
			"GuardTower6",
		],
		[
			"P0-AASite-SAM1",
			"Empl2-Rocket-SAM",
		],
		[
			"Bunker3-Rocket-SAM2Hvy",
			"Bunker2-Rocket-SAMHvy",
		],
		];

		
		this.hardpoints = [
		[
			"WallTower3-Rocket-AT3Hvy",
			"WallTower2-Rocket-AT2Hvy",
			"WallTower-Rocket-ATHvy",
		],
		[
			"WallTower4-Rocket-Gattling",
			"WallTower3-Rocket-Pod3Quad",
			"WallTower2-Rocket-Pod2Quad",
			"WallTower-Rocket-PodQuad",
			"WallTower-Rocket-PodTwin",
		],
		[
			"GuardTower-ATMiss",
			"Tower2-Rocket-AT2",
			"GuardTower5",
		],
		[
			"Tower3-Rocket-Pod3",
			"Tower2-Rocket-Pod2",
			"GuardTower6",
			"Tower-Cannon-Lgt",
			"GuardTower1",
		],
		[
			"Bunker3-Rocket-TopAtkPlasHvy",
			"Bunker2-Rocket-TopAtkIncHvy",
			"Bunker3-Rocket-SeraphHvy",
			"Bunker2-Rocket-TopAttackHvy",
			"Bunker-Rocket-MRLHvy",
		],
		[
			"Empl3-Rocket-TopAtkPlas",
			"Empl2-Rocket-TopAtkInc",
			"Emplacement-MdART-pit",
			"Empl2-Rocket-TopAttack",
			"Emplacement-MRL-pit",
		],
		[
			"Emplacement-MortarEMP",
			"Tower2-EMP-Cannon",
		],
		[
			"Super-MissileArrayPlas-Empl",
			"Super-MissileArray-Empl",
		],
		[
			"X-Super-Missile",
			"X-Super-Rocket",
		],
		];
		
		this.researchPathPrimary = [
			"R-Wpn-Cannon-Damage01",
			"R-Vehicle-Prop-Halftracks",
			"R-Wpn-Rocket05-MiniPod",
			"R-Struc-PowerModuleMk1",
			"R-Defense-Tower-MG1",
			"R-Wpn-Rocket02-MRL",
			"R-Vehicle-Prop-Tracks",
			"R-Wpn-Rocket01-LtAT",
			"R-Sys-Sensor-Tower02",
			"R-Wpn-Rocket06-IDF",
			"R-Defense-Empl2-Rocket-Ripple",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl2-MortarEMP",			//EMP Mortars can be really annoying to deal with.
		];

		this.researchPathFundamental = [
			"R-Vehicle-Prop-Halftracks",
			"R-Struc-RepairFacility",
			"R-Struc-PowerModuleMk1",
			"R-Struc-Research-Module",
			"R-Struc-Factory-Cyborg",
			"R-Struc-WindFarm",
			"R-Vehicle-Prop-Tracks",
			"R-Vehicle-Body04",
			"R-Struc-Factory-Module",
			"R-Vehicle-Body05",
			"R-Vehicle-Body11",
			"R-Struc-Power-Upgrade03",
			"R-Sys-Spade1Hvy",
			"R-Sys-Sensor-Tower02",
			"R-Vehicle-Body23",
			"R-Struc-VTOLPad",
			"R-Struc-VTOLFactory",
			"R-Sys-RadarDetectorTower2",
			"R-Sys-CBSensor-Tower02",
			"R-Struc-Power-Upgrade06",
			"R-Wpn-MortarEMP",
			"R-Vehicle-Armor-Kinetic03",
			"R-Vehicle-Armor-Heat03",
			"R-Sys-Autorepair-General",
			"R-Vehicle-Body09",
			"R-Vehicle-Engine02",
			"R-Sys-Spade2Hvy",
			"R-Defense-Empl2-MortarEMP",
			"R-Struc-RepairFacility2",
			"R-Sys-Resistance-Upgrade01",
			"R-Vehicle-Body25",
			"R-Struc-Power-Upgrade09",
			"R-Vehicle-Armor-Kinetic06",
			"R-Vehicle-Armor-Heat06",
			"R-Sys-Autorepair-Upgrade01",
			"R-Vehicle-Body22",
			"R-Vehicle-Engine03",
			"R-Sys-Spade3Hvy",
			"R-Struc-RepairFacility3",
			"R-Sys-Resistance-Upgrade02",
			"R-Vehicle-Body27",
			"R-Wpn-LasSat",
			"R-Sys-Sensor-WSTower",
			"R-Sys-Sensor-UpLink",
			"R-Vehicle-Armor-Kinetic09",
			"R-Vehicle-Armor-Heat09",
			"R-Sys-Autorepair-Upgrade02",
			"R-Vehicle-Body13",
			"R-Vehicle-Engine05",
			"R-Sys-Spade4Hvy",
			"R-Struc-RepairFacility4",
			"R-Sys-Resistance-Upgrade03",
		];
		
		this.researchPathAT = [
			"R-Wpn-Rocket05-MiniPod",			//Try to minimize the need to research new structure bodies.
			"R-Defense-Tower-MG1",
			"R-Defense-Tower-Cannon-Lgt",
			"R-Defense-Tower-Rocket-Pod",
			"R-Defense-Bunker-Rocket-Pod",
			"R-Defense-Tower-Rocket-AT",
			"R-Defense-Bunker-Rocket-ATHvy",
			"R-Defense-WallTower-Rocket-ATHvy",
			"R-Defense-Bunker-Rocket-PodTwin",
			"R-Defense-WallTower-Rocket-PodTwin",
			"R-Defense-Bunker-Rocket-PodQuad",
			"R-Defense-WallTower-Rocket-PodQuad",
			"R-Defense-Tower2-Rocket-Pod2",
			"R-Defense-Tower2-Rocket-AT2",
			"R-Defense-Empl2-Rocket-Ripple",
			"R-Sys-Sensor-Tower02",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Bunker2-Rocket-AT2Hvy",
			"R-Defense-Bunker2-Rocket-Ripple",
			"R-Defense-Empl2-MortarEMP",			//EMP Mortars can be really annoying to deal with.
			"R-Defense-WallTower2-Rocket-AT2Hvy",
			"R-Defense-Empl-Rocket-MRL",			//Since Flamers aren't prohibitively expensive to research solo,
			"R-Defense-Bunker-Rocket-MRLHvy",		//we'll have the Rocket personality research Incendiary Rocket Arrays,
			"R-Defense-Empl2-Rocket-TopAttack",		//as well as the Mini-Rocket Array and Rocket Assault Array defenses
			"R-Defense-Empl2-Rocket-TopAtkInc",		//that it'll undoubtedly unlock along the way.
			"R-Defense-Bunker2-Rocket-TopAttackHvy",
			"R-Defense-Bunker2-Rocket-TopAtkIncHvy",
			"R-Defense-Bunker2-Rocket-Pod2Quad",
			"R-Defense-WallTower2-Rocket-Pod2Quad",
			"R-Defense-Empl3-TBM-FuelAir",		//TBMs pack a much bigger punch than Archangels.
			"R-Defense-Tower3-Rocket-Pod3",
			"R-Defense-Tower3-Rocket-AT3",
			"R-Defense-Bunker3-Rocket-AT3Hvy",
			"R-Defense-WallTower3-Rocket-AT3Hvy",
			"R-Defense-Empl3-TBM-Precision",
			"R-Wpn-Missile-ROF03",
			"R-Wpn-Missile-Damage03",
			"R-Defense-Bunker3-Rocket-Pod3Quad",
			"R-Defense-WallTower3-Rocket-Pod3Quad",
			"R-Defense-Super-Rocket",
			"R-Wpn-Rocket-Damage09",
			"R-Wpn-Rocket-ROF09",
			"R-Wpn-Rocket-Accuracy09",
			"R-Defense-Super-Missile",
		];
		
		this.researchPathAP = [
			"R-Wpn-Rocket05-MiniPod",
			"R-Defense-Tower-MG1",
			"R-Defense-Tower-Cannon-Lgt",
			"R-Defense-Tower-Rocket-Pod",
			"R-Defense-Bunker-Rocket-Pod",
			"R-Defense-Empl-Rocket-MRL",
			"R-Defense-Bunker-Rocket-MRLHvy",
			"R-Defense-Bunker-Rocket-PodTwin",
			"R-Defense-WallTower-Rocket-PodTwin",
			"R-Defense-Bunker-Rocket-PodQuad",
			"R-Defense-WallTower-Rocket-PodQuad",
			"R-Defense-Empl2-Rocket-Ripple",
			"R-Sys-Sensor-Tower02",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl2-Rocket-TopAttack",
			"R-Defense-Empl2-Rocket-TopAtkInc",
			"R-Defense-Tower2-Rocket-Pod2",
			"R-Defense-Bunker2-Rocket-Ripple",
			"R-Defense-Bunker2-Rocket-TopAttackHvy",
			"R-Defense-Bunker2-Rocket-TopAtkIncHvy",
			"R-Defense-Bunker2-Rocket-Pod2Quad",
			"R-Defense-WallTower2-Rocket-Pod2Quad",
			"R-Defense-Empl3-Rocket-Seraph",
			"R-Defense-Empl3-Rocket-Archangel",
			"R-Defense-Tower3-Rocket-Pod3",
			"R-Defense-Bunker3-Rocket-SeraphHvy",
			"R-Defense-Bunker3-Rocket-Archangel",
			"R-Defense-Bunker3-Rocket-Pod3Quad",
			"R-Defense-WallTower3-Rocket-Pod3Quad",
			"R-Wpn-Rocket-ROF09",
			"R-Wpn-Rocket-Damage09",
			"R-Wpn-Rocket-Accuracy09",
			"R-Defense-Super-MissileArray",
		];
		
		this.researchPathAA = [
			"R-Wpn-Rocket05-MiniPod",
			"R-Defense-Tower-MG1",
			"R-Defense-Tower-Cannon-Lgt",
			"R-Defense-Tower-Rocket-Pod",
			"R-Defense-Bunker-Rocket-Pod",
			"R-Defense-Empl-Rocket-Sunburst",
			"R-Defense-Tower-Rocket-AT",		//We'll need to research Lancers arong the way to researching Solar Flare SAMs anyways.
			"R-Defense-Empl2-Rocket-SAM",
			"R-Defense-Bunker2-Rocket-SAMHvy",
			"R-Defense-Empl3-Rocket-Cherub",
			"R-Defense-Empl3-Rocket-SAM2",
			"R-Defense-Bunker3-Rocket-SAM2Hvy",
			"R-Wpn-Rocket-Damage09",
			"R-Wpn-Rocket-Accuracy09",
			"R-Wpn-Rocket-ROF09",
		];
		
		this.researchPathAB = [
			"R-Wpn-Rocket03-HvAT",
			"R-Defense-Empl2-Rocket-Ripple",
			"R-Sys-Sensor-Tower02",
			"R-Sys-CBSensor-Tower02",
			"R-Sys-RadarDetectorTower2",
			"R-Defense-Empl3-TBM-FuelAir",
			"R-Defense-Empl3-TBM-Precision",
			"R-Wpn-LasSat",
			"R-Wpn-Rocket-BB2",
			"R-Defense-Empl3-TBM-Earthquake",
			"R-Wpn-Missile-ROF03",
			"R-Wpn-Rocket-Damage09",
			"R-Wpn-Rocket-ROF09",
			"R-Wpn-Rocket-Accuracy09",
		];
		
		//Although the AI will eventually pursue these research items when it has run out of things to pursue,
		//it will also pursue them the moment they become available for direct research.
		this.researchPathExotic = [
			"R-Wpn-Rocket-TopAtkPlas",
			"R-Defense-Empl3-Rocket-TopAtkPlas",
			"R-Wpn-Rocket-TopAtkPlasHvy",
			"R-Defense-Bunker3-Rocket-TopAtkPlasHvy",
			"R-Wpn-Rocket-TopAtkInc",
			"R-Defense-Empl2-Rocket-TopAtkInc",
			"R-Wpn-Rocket-TopAtkIncHvy",
			"R-Defense-Bunker2-Rocket-TopAtkIncHvy",
			"R-Wpn-TBM-Plasmite",
			"R-Defense-Empl3-TBM-Plasmite",
			"R-Defense-Super-MissileArrayPlas",
			"R-Wpn-Rocket-LasProp-AP",
			"R-Defense-Empl4-Rocket-LasProp-AP",
			"R-Wpn-Rocket-LasProp-AT",
			"R-Defense-Empl4-Rocket-LasProp-AT",
			"R-Wpn-Rocket-LasProp-Plas",
			"R-Defense-Empl4-Rocket-LasProp-Plas",
			"R-Wpn-HowitzerGaussRamjet",
			"R-Defense-Empl4-HowitzerGaussRamjet",
			"R-Wpn-HowitzerGaussRamjetHvy",
			"R-Defense-Bunker4-HowitzerGaussRamjetHvy",
			"R-Wpn-HowitzerGaussRamjetRot",
			"R-Defense-Bunker4-HowitzerGaussRamjetRot",
			"R-Defense-Super-HowitzerRamjet",
			"R-Defense-Super-HowitzerGaussRamjet",
			"R-Wpn-HowitzerRamjet",
			"R-Defense-Empl3-HowitzerRamjet",
			"R-Wpn-HowitzerRamjetHvy",
			"R-Defense-Bunker3-HowitzerRamjetHvy",
			"R-Wpn-HowitzerRamjetRot",
			"R-Defense-Bunker3-HowitzerRamjetRot",
			"R-Wpn-Mortar-GaussRamjet",
			"R-Defense-Empl4-Mortar-GaussRamjet",
			"R-Wpn-Mortar-GaussRamjetHvy",
			"R-Defense-Bunker4-Mortar-GaussRamjetHvy",
			"R-Wpn-Mortar-GaussRamjetRot",
			"R-Defense-Bunker4-Mortar-GaussRamjetHvy",
			"R-Defense-Super-MortarRamjet",
			"R-Defense-Super-MortarGaussRamjet",
			"R-Wpn-Mortar-Ramjet",
			"R-Defense-Empl3-Mortar-Ramjet",
			"R-Wpn-Mortar-RamjetHvy",
			"R-Defense-Bunker3-Mortar-RamjetHvy",
			"R-Wpn-Mortar-RamjetRot",
			"R-Defense-Bunker3-Mortar-RamjetRot",
			"R-Wpn-Cannon-Ramjet",
			"R-Wpn-Cannon-Ramjet-TankDest",
			"R-Defense-Bunker3-Cannon-Ramjet",
			"R-Defense-WallTower3-Cannon-Ramjet",
			"R-Wpn-Rocket-Gattling",
			"R-Defense-Bunker4-Rocket-Gattling",
			"R-Defense-WallTower4-Rocket-Gattling",
		];

	break;
	case 4: //Artillery Personality
		
		//To be worked on as a replacement for the Turtle Personality...
		
	break;
	}
}

function rnd() {
	return (random(5)-2)*100;
}

function setTimers() {
	setTimer("updateStatus",		2000+rnd());
	setTimer("huntForOil", 			7000+rnd());
	setTimer("doResearch", 			12000+rnd());
	setTimer("executeBuildOrder",		5000+rnd());
	setTimer("attackStuff",			3000+rnd());
	setTimer("vtolAttack",			10000+rnd());
	//setTimer("cheat",			30000+rnd());
	setTimer("becomeHarder",		480000+rnd());
	setTimer("adapt",				30000+rnd());
	setTimer("changeProductionRates",	120000+rnd());
	setTimer("sendAllForRepair",		1000+rnd());
	setTimer("demolishHotspotStructs",	1000+rnd());
	setTimer("produceDroids",		3000+rnd());
	setTimer("relaxStats",			10000+rnd());
	setTimer("balanceGroups",		10000+rnd());
	setTimer("recycleTrucks",		30000+rnd());
	setTimer("returnDefendersToBase",	20000+rnd());
	setTimer("callUpdateEnemyInfo",	2000+rnd());
	setTimer("harassStuff",			3000+rnd());
	setTimer("buildWindFarm",		60000+rnd());
	setTimer("buildArtillery",		3000+rnd());
	setTimer("buildProxyFactory",		4000+rnd());
	setTimer("buildRepairFacility",	30000+rnd());
	setTimer("buildLookoutTower",		3000+rnd());
	setTimer("buildAADefense",		4000+rnd());
	if (REGROUP_FREQUENCY>0)
		setTimer("regroupRegularly",		REGROUP_FREQUENCY+rnd());
}

//Set build order based on what role the AI will serve in a team.
function setBuildOrder() {
	if (difficulty==EASY)
		return;
	buildOrder = [factory,lab,lab,command,factory,generator,generator,borgfac,vtolfac,borgfac,vtolfac];
	//Although Cyborg and VTOL factories would probably never get built at the start of T1 games,
	//having them in the build list can be helpful for determining how many of each the AI should maintain.
	switch (teamRole) {
	case TEAM_ROLE_SUPPORT: //Stay back and assist vanguard players with their rushes and assaults through research.
		buildOrder = [lab,factory,lab,lab,command,factory,generator,generator,borgfac,vtolfac,borgfac,vtolfac];
		break;
	case TEAM_ROLE_VANGUARD: //Attempt to rush opponents with tanks, relying on support players for research.
		buildOrder = [factory,command,factory,lab,generator,generator,lab,borgfac,vtolfac,borgfac,vtolfac];
		break;
	case TEAM_ROLE_NORMAL: //Used by AIs that are not in a team, or are in the middle of the team.
		buildOrder = [factory,lab,lab,command,factory,generator,generator,borgfac,vtolfac,borgfac,vtolfac];
		break;
	}
	if (scavengers) { 
		if (enumStruct(scavengerPlayer,FACTORY).length || enumStruct(scavengerPlayer,VTOL_FACTORY).length) {
			//We'll need a more research-oriented build order if Scavengers are present.
			buildOrder = [lab,lab,factory,command,factory,generator,generator,borgfac,vtolfac,borgfac,vtolfac];
			personality.PEACE_TIME=0;	//No sense rushing if a Scavenger player stands between us and the enemy.
			//MIN_DEFENSES_AA=8;		//This is in case the Scavengers are capable of building VTOLs (such as in the Ultimate Scavenger Mod).
			MIN_DEFENDERS_AA=16;
		}
	}
	if (RATE_TANK == 0 && RATE_HOVER > 0) {
		//We'll need to research rush for hovers if our only opponents are located on the other side of a body of water.
		buildOrder = [lab,factory,lab,lab,generator,generator,factory,vtolfac,vtolfac]; //We won't need combat units for a long time, so no HQ is specified here (though should be built anyways via keepBuildingThings()).
		personality.THIS_AI_MAKES_CYBORGS = false;	//We won't need cyborgs for a water map.
		personality.PEACE_TIME=16;				//14 minutes should be enough time to research rush for hover propulsion.
		personality.MIN_DEFENDERS = 32;			//We'll most likely have a surplus of power when we finally have hovers.
		personality.MIN_OILERS = 4;				//The body of water that separates us from the other players should be all the defense we need until they start producing hovers of their own.
		personality.MAX_OILERS = 8;
	}
}

function myBuildOrder() {
	/*if (status==STATUS_PANIC) //It's too dangerous to build in our base if it's in danger of falling.
		return false;*/
	var labCount = enumStruct(me, lab).length;
	var factoryCount = enumStruct(me, factory).length;
	var commandCount = enumStruct(me, command).length;
	var genCount = enumStruct(me, generator).length;
	var derrickCount = enumStruct(me, derrick).length;
	var borgfacCount = enumStruct(me, borgfac).length;
	var vtolfacCount = enumStruct(me, vtolfac).length;
	
	var labTarget = 0;
	var factoryTarget = 0;
	var commandTarget = 0;
	var genTarget = 0;
	var derrickTarget = 0;
	var borgfacTarget = 0;
	var vtolfacTarget = 0;
	
	if (playerPower(me) < EXTREME_LOW_POWER) { //Build power generator and nearby derricks if almost out of power.
		if (genCount < 1 && isStructureAvailable(generator,me))
			return buildBasicStructure(generator);
		else if (derrickCount < 3 && isStructureAvailable(derrick,me) && enumFeature(-1,oilres)>0) {
			return secureBaseOil();
		}
	}
	for (var i=0; i < buildOrder.length; ++i) {
		if (typeof(buildOrder[i])!="string")
			debug("ERROR: Index ",i," of player ",me,"'s build list isn't a string. The listed index will be ignored.");
		else {
			switch (buildOrder[i]) {
			case lab:
				labTarget += 1;
				if (labCount < labTarget && isStructureAvailable(lab,me))
					return buildBasicStructure(lab);
				break;
			case factory:
				factoryTarget += 1;
				if (factoryCount < factoryTarget && isStructureAvailable(factory,me))
					return buildBasicStructure(factory);
				break;
			case command:
				commandTarget += 1;
				if (commandCount < commandTarget && isStructureAvailable(command,me))
					return buildBasicStructure(command);
				break;
			case generator:
				genTarget += 1;
				if (genCount < genTarget && isStructureAvailable(generator,me))
					return buildBasicStructure(generator);
				break;
			case derrick:
				derrickTarget += 1;
				if (derrickCount < derrickTarget && isStructureAvailable(derrick,me))
					return buildBasicStructure(derrick);
				break;
			case borgfac:
				borgfacTarget += 1;
				if (borgfacCount < borgfacTarget && isStructureAvailable(borgfac,me) && personality.THIS_AI_MAKES_CYBORGS==true)
					return buildBasicStructure(borgfac);
				break;
			case vtolfac:
				vtolfacTarget += 1;
				if (vtolfacCount < vtolfacTarget && isStructureAvailable(vtolfac,me) && personality.THIS_AI_MAKES_VTOLS==true)
					return buildBasicStructure(vtolfac);
				break;
			default:
				debug("ERROR: Index ",i," of player ",me,"'s build list contains an invalid object. The listed index will be ignored.");
			}
		}
	}
	secureBaseOil();
	return false;
}
